/**
 * Created by Administrator on 2015/8/28.
 */
function CardUIManager()
{

}


CardUIManager.createSelectCardUIAction = function()
{
    var action = cc.moveBy(0.5,0,20);
    action.easing(cc.easeBackOut());
    return action;
}

CardUIManager.createUnSelectCardUIAction = function()
{
    var action = cc.moveBy(0.5,0,-20);
    action.easing(cc.easeBackOut());
    return action;
}

CardUIManager.createHandCard = function(cardNum,cardType)
{

    var cardBG = new cc.Sprite("#handcardbg.png");
    cardBG.setAnchorPoint(cc.p(0,0));

    var cardCover = new cc.LayerColor(cc.color(255,165,0,100),118,170);
    cardCover.setAnchorPoint(cc.p(0,0));
    cardCover.setPosition(cc.p(6.0,9.0));
    cardCover.setVisible(false);
    cardCover.setLocalZOrder(100);
    cardBG.addChild(cardCover);
    cardBG.CardOverUI = cardCover;
    cardBG.MarginLeft = 0;
    cardBG.MarginRight = 0;
    cardBG.DesignX = 0;
    cardBG.DesignY = 0;

    cardBG.Selected = false;

    if(cardType == 5)
    {
        var smallTypeS = "#5-"+cardNum+".png";
        var cardSmallType = new cc.Sprite(smallTypeS);
        cardSmallType.setAnchorPoint(cc.p(0,0));
        cardSmallType.setPosition(cc.p(9,116));
        cardBG.addChild(cardSmallType);
        return cardBG;
    }
    else
    {
        var cardTypeS = "#"+cardType+"-1.png";
        var cardTypeUI = new cc.Sprite(cardTypeS);
        cardTypeUI.setAnchorPoint(cc.p(0,0));
        cardTypeUI.setPosition(cc.p(6.02,11.30));

        var cardSmallTypeS ="#"+cardType+"-4.png";
        var cardSmallType = new cc.Sprite(cardSmallTypeS);
        cardSmallType.setAnchorPoint(cc.p(0,0));
        cardSmallType.setPosition(cc.p(1,105.86));

        var jiou = cardType%2;
        jiou = jiou == 0?2:jiou;
        var cardNumS = "#"+cardNum+"-"+jiou+"-1.png";
        var cardNum = new cc.Sprite(cardNumS);
        cardNum.setAnchorPoint(cc.p(0,0));
        cardNum.setPosition(cc.p(5,140));

        cardBG.addChild(cardTypeUI);
        cardBG.addChild(cardSmallType);
        cardBG.addChild(cardNum);

        return cardBG;
    }
}

CardUIManager.createHitCard = function(cardNum,cardType)
{
    var cardBG = new cc.Sprite("#hitcardbg.png");
    cardBG.setAnchorPoint(cc.p(0,0));
    cardBG.MarginLeft = 0;
    cardBG.MarginRight = 0;

    //添加大的图标
    var bigIcon = new cc.Sprite("#Big.png");
    bigIcon.setPosition(cc.p(52.09,83.02));
    cardBG.bigIcon = bigIcon;//方便访问bigicon
    bigIcon.setVisible(false);
    cardBG.addChild(bigIcon);

    //添加杀图标
    var shaIcon = new cc.Sprite("#sha.png");
    shaIcon.setPosition(cc.p(51.25,32.02));
    cardBG.shaIcon = shaIcon;//方便访问bigicon
    shaIcon.setVisible(false);
    cardBG.addChild(shaIcon);

    if(cardType == 5)
    {
        var smallTypeS = "#5-"+cardNum+".png";
        var cardSmallType = new cc.Sprite(smallTypeS);
        cardSmallType.setAnchorPoint(cc.p(0,0));
        cardSmallType.setPosition(cc.p(12,52));
        cardBG.addChild(cardSmallType);
        return cardBG;
    }
    else
    {
        var cardTypeS = "#"+cardType+"-3.png";
        var cardTypeUI = new cc.Sprite(cardTypeS);
        cardTypeUI.setAnchorPoint(cc.p(0,0));
        cardTypeUI.setPosition(cc.p(18.76,21.36));

        var jiou = cardType%2;
        jiou = jiou == 0?2:jiou;
        var cardNumS = "#"+cardNum+"-"+jiou+"-1.png";
        var cardNum = new cc.Sprite(cardNumS);
        cardNum.setAnchorPoint(cc.p(0,0));
        cardNum.setPosition(cc.p(7,73.96));

        cardBG.addChild(cardTypeUI);
        cardBG.addChild(cardNum);
        return cardBG;
    }
}

CardUIManager.createEatScorePlaneCard = function(cardNum,cardType)
{
    var cardBG = new cc.Sprite("#smallcardbg.png");
    cardBG.setAnchorPoint(cc.p(0,0));
    cardBG.setPosition(cc.p(0,20));
    cardBG.MarginLeft = 0;
    cardBG.MarginRight = 0;
    if(cardType == 5)
    {
        var smallTypeS = "#5-"+cardNum+".png";
        var cardSmallType = new cc.Sprite(smallTypeS);
        cardSmallType.setAnchorPoint(cc.p(0,1));
        cardSmallType.setPosition(cc.p(14.38,52));
        cardBG.addChild(cardSmallType);
        return cardBG;
    }
    else
    {
        var cardTypeS = "#"+cardType+"-4.png";
        var cardTypeUI = new cc.Sprite(cardTypeS);
        cardTypeUI.setPosition(cc.p(20.00,19.00));

        var jiou = cardType%2;
        jiou = jiou == 0?2:jiou;
        var cardNumS = "#"+cardNum+"-"+jiou+"-2.png";
        var cardNum = new cc.Sprite(cardNumS);
        cardNum.setPosition(cc.p(14.38,44.68));

        cardBG.addChild(cardTypeUI);
        cardBG.addChild(cardNum);
        return cardBG;
    }

}

CardUIManager.getZhuTypeFrame = function(cardType)
{
    var frameName = cardType+"-3.png";
    return cc.spriteFrameCache.getSpriteFrame(frameName);
}