/**
 * Created by Administrator on 2016/1/15.
 */
function EventListenerManager(sender)
{
    this.sender = sender;
    this.eventMap = {};
}
EventListenerManager.prototype.addEventListener = function(name,callback)
{
    this.eventMap[name] = callback;
}
EventListenerManager.prototype.removeListener = function(name)
{
    this.eventMap[name] = null;
}
EventListenerManager.prototype.removeAllListener = function()
{
    this.eventMap = {};
}
EventListenerManager.prototype.notifyEvent = function()
{
    for(var key in this.eventMap)
    {
        var oneEvent = this.eventMap[key];
        if(typeof oneEvent == "undefined" || oneEvent ==null)continue;
        oneEvent(this.sender);
    }
}