/**
 * Created by Administrator on 2015/8/20.
 */
//游戏相关的所有UI操作都在这里进行
function GuiController()
{

}

GuiController.LoginUI = null;
GuiController.ChooseGameUI = null;
GuiController.HallUIForOneLun = null;
GuiController.CurrentUI = null;
GuiController.ScreenWidth = 1280;
GuiController.ScreenHeight = 720;

GuiController.getCenterSceenPos  = function()
{
    var x = GuiController.ScreenWidth/2.0;
    var y = GuiController.ScreenHeight/2.0;
    return  cc.p(x,y);
}

//通用的等待显示界面
GuiController.showWaitingUI = function(waitingUI,text,sec,callback)
{

    waitingUI.setVisible(true);
    var textUI = waitingUI.getChildByName("LoadingText");
    textUI.setString(text);
    textUI.cleanup();
    var fadeInAndOutActions = cc.sequence(cc.fadeIn(1),cc.fadeOut(1));
    var foreverAction = cc.repeatForever(fadeInAndOutActions);
    textUI.runAction(foreverAction);

    if(sec == Number.MAX_VALUE)return;
    waitingUI.schedule(function()
    {
        waitingUI.setVisible(false);
        textUI.cleanup();
        if(typeof  callback != "undefined")callback();
    },sec,1)

}

//在屏幕中心显示一个webview
GuiController.showWebViewCenter = function(layer,url)
{
    var webViewLayer = new cc.Layer();

    var backGround = new ccui.Layout();
    backGround.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
    backGround.setBackGroundColor(cc.color(139, 105, 20));
    backGround.setContentSize(cc.size(1020,620));
    backGround.setAnchorPoint(cc.p(0.5,0.5));
    backGround.setTouchEnabled(true);
    backGround.setPosition(GuiController.getCenterSceenPos());
    webViewLayer.addChild(backGround);

    var webView = new ccui.WebView(url);
    webView.setContentSize(1000,600);
    webView.setAnchorPoint(cc.p(0.5,0.5));
    webView.setPosition(GuiController.getCenterSceenPos());
    webViewLayer.addChild(webView);

    //添加关闭按钮
    var closeImage = new ccui.ImageView(res.CloseIconPng);
    closeImage.setAnchorPoint(new cc.p(0.5,0.5));
    closeImage.setTouchEnabled(true);
    var closeX = 1128;
    var closeY = 690;
    closeImage.setFocused(true);
    closeImage.setPosition(closeX,closeY);
    webViewLayer.addChild(closeImage);

    CocosHeler.setOnClickEvent(closeImage,function()
    {
        layer.removeChild(webViewLayer);
    });

    layer.addChild(webViewLayer);
}

GuiController.showChooseGameInfo = function()
{

}

GuiController.playerInfoUI_InitEvent = function(playerInfoUI)
{
    var plane =  playerInfoUI.getChildByName("PlayerInfoPlane");
    var namePlane = playerInfoUI.getChildByName("NamePlane");
    var closeBn = plane.getChildByName("CloseBn");
    var sysInfo = plane.getChildByName("SystemInfo");
    var howToPlay = plane.getChildByName("HowToPlay");

    CocosHeler.setOnClickEvent(sysInfo,function()
    {
        GuiController.showWebViewCenter(playerInfoUI.getParent(),"http://www.datonghuolong.com/gonggao");
    },this);
    //点击名字面板
    CocosHeler.setOnClickEvent(namePlane,function()
    {
        g_GameNetWork.crossSendData("questuserinfo","");
        g_SoundManager.playShowMenuSound();
    },this);

    //点击关闭按钮
    CocosHeler.setOnClickEvent(closeBn,function()
    {
        CocosHeler.runAnimation(playerInfoUI,res.ShowPlayerInfoAction,"HideInfoPlane");
        g_SoundManager.playShowMenuSound();
    },this);

    //单击如何玩事件
    CocosHeler.setOnClickEvent(howToPlay,function()
    {
        GuiController.showWebViewCenter(playerInfoUI.getParent(),"http://www.datonghuolong.com/gonggao");
    },this);
}

GuiController.playerInfoUI_ShowPlayerInfo = function(playerInfoUI,data)
{
    var name = data.name;
    var normalscore = data.normalscore;
    var paiming = data.paiming;
    GameGloble.Chenghao = data.chenghao;
    GameGloble.LongGu = data.longgu;
    var plane = playerInfoUI.getChildByName("PlayerInfoPlane");
    plane.getChildByName("PlaneName").setString(name);
    plane.getChildByName("ChengHaoText").setString(data.chenghao);
    plane.getChildByName("NormalScoreText").setString(normalscore+"分");
    plane.getChildByName("LonguText").setString(data.longgu.toFixed(1)+"龙骨");
    plane.getChildByName("PaimingText").setString("第"+paiming+"名");
    CocosHeler.runAnimation(playerInfoUI,res.ShowPlayerInfoAction,"ShowInfoPlane");
}


GuiController.initMessageBoxEvent = function(messageBox,okEvent,cancleEvent)
{
    var okBn = messageBox.getChildByName("OkBn");
    var cancleBn = messageBox.getChildByName("CancleBn");
    var closeBn = messageBox.getChildByName("CloseBn");
    CocosHeler.setOnClickEvent(okBn,okEvent);
    CocosHeler.setOnClickEvent(cancleBn,cancleEvent);
    CocosHeler.setOnClickEvent(closeBn,cancleEvent);
}

//添加商城事件,比如关闭事件，充值事件
GuiController.initChongZhiUI = function(chongzhiui)
{

    var closeBn = chongzhiui.getChildByName("Close");
    CocosHeler.setOnClickEvent(closeBn,function(ui)
    {
        this.setVisible(false);
    },chongzhiui);

    //统一充值UI
    var normalPayUI = chongzhiui.getChildByName("ChongzhiInfo");
    var normalPayClose = normalPayUI.getChildByName("Close");
    CocosHeler.setOnClickEvent(normalPayClose,function()
    {
        normalPayUI.setVisible(false);
    },chongzhiui);

    //1块钱按钮
    var bn1 = chongzhiui.getChildByName("1");
    CocosHeler.setOnClickEvent(bn1,function()
    {
        PayManager.pay(PayManager.payCode1,1,normalPayUI);
    },chongzhiui);
    //3块钱按钮
    var bn3 = chongzhiui.getChildByName("3");
    CocosHeler.setOnClickEvent(bn3,function()
    {
        PayManager.pay(PayManager.payCode1,3,normalPayUI);
    },chongzhiui);
    //10块钱按钮
    var bn10 = chongzhiui.getChildByName("10");
    CocosHeler.setOnClickEvent(bn10,function()
    {
        PayManager.pay(PayManager.payCode1,10,normalPayUI);
    },chongzhiui);
    //30块钱按钮
    var bn30 = chongzhiui.getChildByName("30");
    CocosHeler.setOnClickEvent(bn30,function()
    {
        PayManager.pay(PayManager.payCode2,3,normalPayUI);
    },chongzhiui);
    //50块钱按钮
    var bn50 = chongzhiui.getChildByName("50");
    CocosHeler.setOnClickEvent(bn50,function()
    {
        PayManager.pay(PayManager.payCode2,5,normalPayUI);
    },chongzhiui);
    //100块钱按钮

    //点击兑换现金
    var duihuanBn = chongzhiui.getChildByName("DuiHuanBn");
    CocosHeler.setOnClickEvent(duihuanBn,function()
    {
        this.getChildByName("DuihuanBG").setVisible(true);
    },chongzhiui);
    var duihuanCloseBn = chongzhiui.getChildByName("DuihuanBG").getChildByName("Close");
    CocosHeler.setOnClickEvent(duihuanCloseBn,function()
    {
        this.getChildByName("DuihuanBG").setVisible(false);
    },chongzhiui);

}

//在屏幕中心位置创建一个文字输入框，用来输入文字
GuiController.createGameEditBox = function(okEvent)
{
    var blackLayer = new cc.LayerColor(cc.color(0,0,0,200),1280,720);
    blackLayer.okEvent = okEvent;
    //blackLayer.setTouchEnabled(true);
    var box = new cc.EditBox(cc.size(700, 90), new cc.Scale9Sprite(GameGloble.ResPath+"yellow_edit.png"));
    box.setPlaceholderFontColor(cc.color(0, 0, 0,255));
    box.setPlaceHolder("输入您想说的话，不能超过15个字符");
    box.setPlaceholderFontSize(30);
    box.setFontSize(30);
    box.setFontColor(cc.color(0,0,0,255));
    box.x = 640;
    box.y = 720 - 200;
    blackLayer.addChild(box);
    blackLayer.editBoxUI = box;

    //添加确定按钮
    var okBn = new ccui.Button(GameGloble.ResPath+"animationbuttonnormal.png", GameGloble.ResPath+"animationbuttonpressed.png");
    okBn.setTitleText("确定")
    okBn.setTitleFontSize(30);
    okBn.setPressedActionEnabled(true);
    okBn.x = 900;
    okBn.y = 720 - 300;
    blackLayer.addChild(okBn);
    okBn.addClickEventListener(function()
    {
        okEvent();
    });

    //添加取消按钮
    var cancleBn = new ccui.Button(GameGloble.ResPath+"animationbuttonnormal.png", GameGloble.ResPath+"animationbuttonpressed.png");
    cancleBn.setTitleText("取消")
    cancleBn.setTitleFontSize(30);
    cancleBn.setPressedActionEnabled(true);
    cancleBn.x = 720;
    cancleBn.y = 720 - 300;
    cancleBn.addClickEventListener(function()
    {
        blackLayer.hideEdit();
    });
    blackLayer.addChild(cancleBn);

    blackLayer.showEdit = function()
    {
        box.string = "";
        blackLayer.setVisible(true);
    }

    blackLayer.hideEdit = function()
    {
        blackLayer.setVisible(false);
    }
    blackLayer.setLocalZOrder(10000000000);
    return blackLayer;
}


//初始化游戏设置界面
GuiController.initGameSetUI = function (root) {
    var shezhiBn = root.getChildByName("ShezhiBn");
    var gameSetUIRoot = root.getChildByName("GameSetUI");
    var plane = gameSetUIRoot.getChildByName("Plane");
    var closeBn = plane.getChildByName("Close");
    var soundBn = plane.getChildByName("Sound");
    var musicBn = plane.getChildByName("Music");
    var genghuanBn = plane.getChildByName("GenghuanBn");

    var canPlaySound = LocalConfig.getCanPlaySound();
    var canPlayMusic = LocalConfig.getCanPlayMusic();

    soundBn.setSelected(!canPlaySound);
    musicBn.setSelected(!canPlayMusic);

    g_SoundManager.setCanPlaySound(canPlaySound);
    g_SoundManager.setCanPlayMusic(GameGloble.IsPlaying, canPlayMusic);
    //设置界面显示状态

    CocosHeler.setOnClickEvent(closeBn,function(wigit)
    {
        this.setVisible(false);
        Ads.hideGDTBanner();
    },gameSetUIRoot);

    CocosHeler.setSelectEvent(soundBn,function(isSelect)
    {
        g_SoundManager.setCanPlaySound(!isSelect);
        LocalConfig.setCanPlaySound(""+!isSelect);
    });
    CocosHeler.setSelectEvent(musicBn,function(isSelect)
    {
        g_SoundManager.setCanPlayMusic(GameGloble.IsPlaying,!isSelect);
        LocalConfig.setCanPlayMusic(""+!isSelect);
    });
    CocosHeler.setOnClickEvent(shezhiBn,function()
    {
        g_SoundManager.playShowMenuSound();
        gameSetUIRoot.setVisible(true);
        Ads.showGDTBanner();
    },this);

    CocosHeler.setOnClickEvent(genghuanBn,function()
    {
        GameGloble.g_webSocketClient.close();
        cc.sys.localStorage.setItem("CanAutoLogin",0);//不自动登录
        cc.director.runScene(new LoginUIScene());
    },this);
}

GuiController.initMessageBox = function(root,text,okEvent,cancleEvent)
{
    var mesPlane = root.getChildByName("Plane");
    var mesBG = mesPlane.getChildByName("BG");
    var okBn = mesBG.getChildByName("OkBn");
    var cancleBn = mesBG.getChildByName("CancleBn");
    var mesTitle = mesBG.getChildByName("Title");
    mesTitle.setString(text);

    root.titleUI = mesTitle;
    CocosHeler.setOnClickEvent(okBn,function(okBn)
    {
        if(typeof  okEvent != "undefined" && okEvent != null)okEvent();

    },root);

    CocosHeler.setOnClickEvent(cancleBn,function(okBn)
    {
        if(typeof  cancleEvent != "undefined" && cancleEvent != null)
        {
            root.setVisible(false);
            cancleEvent();
        }
    },root);

    mesPlane.showMessageBox =  function()
    {
        mesPlane.setVisible(true);
        root.setVisible(true);
        CocosHeler.runAnimation(root,res.MessageBoxAction,"ShowBox",false);
    };

    return  mesPlane;
}

GuiController.initQuitGameUI = function(root)
{
    var mesRoot = root.getChildByName("QuitGameUI");
    GuiController.initMessageBox(mesRoot,"确定退出游戏?",function()
    {
        //确定退出
        cc.director.end();
    },function()
    {
        Ads.hideGDTBanner();
        mesRoot.setVisible(false);
    });

    cc.eventManager.addListener({
        event: cc.EventListener.KEYBOARD,
        onKeyReleased: function(keyCode, event) {
            if (keyCode == cc.KEY.back) {    //beta版本这里的back的keycode有误，也可以自行改为6
                mesRoot.showMessageBox();
            }
        }}, root);
    mesRoot.showMessageBox =  function()
    {
        mesRoot.setVisible(true);
        CocosHeler.runAnimation(mesRoot,res.MessageBoxAction,"ShowBox",false);
        Ads.showGDTBanner();
    };
    return mesRoot;
}

GuiController.initNormalMessageUI = function(root)
{
    var mesRoot = root.getChildByName("NormalMessageUI");
    GuiController.initMessageBox(mesRoot,"确定退出游戏?",function()
    {
        //确定退出
        Ads.hideGDTBanner();
        mesRoot.setVisible(false);
    },function()
    {
        Ads.hideGDTBanner();
        mesRoot.setVisible(false);
    });
    mesRoot.showNormalMessage = function(message)
    {
        mesRoot.setVisible(true);
        Ads.showGDTBanner();
        mesRoot.titleUI.setString(message);
        CocosHeler.runAnimation(root,res.MessageBoxAction,"ShowBox",false);
    }
    return mesRoot;
}

GuiController.initBasePlayerInfoUI = function(root)
{
    var basePlayerInfo = root.getChildByName("BaseInfoPlane");
    var baseInfoPlaneBG = basePlayerInfo.getChildByName("Plane");
    var baseInfoBG = basePlayerInfo.getChildByName("Plane").getChildByName("BG");
    var bipHeadUI = baseInfoBG.getChildByName("Head");
    var bipName = baseInfoBG.getChildByName("Name");
    var bipChenghao = baseInfoBG.getChildByName("Chenghao");
    var bipLonggu = baseInfoBG.getChildByName("Longgu");
    var bipLunNun = baseInfoBG.getChildByName("LunNun");
    var bipCloseBn = baseInfoBG.getChildByName("CloseBn");
    var bipMingci = baseInfoBG.getChildByName("Mingci");
    CocosHeler.setOnClickEvent(bipCloseBn,function(wigiet)
    {
        basePlayerInfo.setVisible(false);
        Ads.hideGDTBanner();
    },this);
    //点击背景
    CocosHeler.setOnClickEvent(baseInfoPlaneBG,function(wigeit)
    {
        basePlayerInfo.setVisible(false);
        Ads.hideGDTBanner();
    },this);

    basePlayerInfo.showInfo = function(headUrl,name,longgu,longnum,chenghao,mingci)
    {
        basePlayerInfo.setVisible(true);
        bipHeadUI.loadTexture(headUrl);
        bipName.setString(name);
        bipChenghao.setString(chenghao);
        bipLonggu.setString(longgu.toFixed(2));
        bipLunNun.setString(longnum);
        bipMingci.setString("第"+mingci+"名");

        Ads.showGDTBanner();
    }
    return basePlayerInfo;
}

//初始化游戏帮助界面
GuiController.initGameHelperUI = function(root)
{
    var helpBn = root.getChildByName("BangzhuBn");
    var helpRoot = root.getChildByName("GameHelperUI");
    var helpPlane = helpRoot.getChildByName("Plane");
    var helpClose = helpPlane.getChildByName("Close");
    CocosHeler.setOnClickEvent(helpBn,function()
    {
        helpRoot.setVisible(true);
        Ads.showGDTBanner();
    },root);
    CocosHeler.setOnClickEvent(helpClose,function()
    {
        helpRoot.setVisible(false);
        Ads.hideGDTBanner();
    },root);
    CocosHeler.setOnClickEvent(helpPlane,function()
    {
        helpRoot.setVisible(false);
        Ads.hideGDTBanner();
    },root);
}
var getHttpData = function(url,callback)
{
    var httpRequest = cc.loader.getXMLHttpRequest();
    httpRequest.open("GET",url,true);
    httpRequest.onreadystatechange = function(e)
    {
        if (httpRequest.readyState == 4 && httpRequest.status == 200)
        {
            var text = httpRequest.responseText;
            callback(text);
        }
    };
    httpRequest.send();
}
//初始化名次界面
GuiController.initMingciUI = function(root)
{
    var mingciBn = root.getChildByName("MingciBn");
    var mingciUI = root.getChildByName("PaimingUI");
    var mingciPanel = mingciUI.getChildByName("Panel");
    var mingciCloseBn = mingciUI.getChildByName("CloseBn");
    var index = 0;
    var childs = mingciUI.getChildren();
    mingciUI.showInfo = function(index,nicheng,chenghao,longgu,longnum)
    {
        var element = childs[index+1];
        element.getChildByName("Nicheng").setString(nicheng);
        element.getChildByName("Chenghao").setString(chenghao);
        element.getChildByName("Longgu").setString(longgu);
        element.getChildByName("Lunshu").setString(longnum);
    }

    CocosHeler.setOnClickEvent(mingciBn,function()
    {
        NativeHelper.callNativeFunctionCoutEvent("ShowPaiming");
        getHttpData("http://www.datonghuolong.com/longgumingci",function(data)
        {
            var players = JSON.parse(data).players;
            var index = 0;
            for(var key in players)
            {
                var onePlayer = players[key];
                mingciUI.showInfo(index,onePlayer.name,onePlayer.chenghao,onePlayer.longgu.toFixed(1),onePlayer.lunshu);
                index+=1;
                if(index==10)return;
            }
        });
        mingciUI.setVisible(true);
        Ads.showGDTBanner();
    },root);

    CocosHeler.setOnClickEvent(mingciPanel,function()
    {
        mingciUI.setVisible(false);
        Ads.hideGDTBanner();
    },root);

    CocosHeler.setOnClickEvent(mingciCloseBn,function()
    {
        mingciUI.setVisible(false);
        Ads.hideGDTBanner();
    },root);

    return mingciUI;
}


GuiController.initAndShowOneceUpdateUI = function(root)
{
    //判断是否显示
    var localVersion = cc.sys.localStorage.getItem("Version");
    if(localVersion == GameGloble.Version)return;
    cc.sys.localStorage.setItem("Version",GameGloble.Version);

    var helpRoot = root.getChildByName("UpdateUI");
    var helpPlane = helpRoot.getChildByName("Plane");
    var helpClose = helpPlane.getChildByName("Close");
    CocosHeler.setOnClickEvent(helpClose,function()
    {
        helpRoot.setVisible(false);
    },root);
    CocosHeler.setOnClickEvent(helpPlane,function()
    {
        helpRoot.setVisible(false);
    },root);
    helpRoot.setVisible(true);
}

GuiController.initFindPassWord = function(root)
{
    var messgeBox = root.getChildByName("FindPassWord");
    GuiController.initMessageBox(messgeBox,"",function()
    {
        messgeBox.setVisible(false);
    },function()
    {
        messgeBox.setVisible(false);
    });
    messgeBox.showFindPassWord = function(text)
    {
        messgeBox.setVisible(true);
        messgeBox.titleUI.setString(text);
        CocosHeler.runAnimation(messgeBox,res.MessageBoxAction,"ShowBox",false);
    }



    var userInputUI = root.getChildByName("UserEnterFindPassWordUI");
    var account = userInputUI.getChildByName("Account");
    var shouji = userInputUI.getChildByName("Shouji");
    var okBn = userInputUI.getChildByName("OkBn");
    var closeBn = userInputUI.getChildByName("CloseBn");

    //点击忘记密码按钮
    CocosHeler.setOnClickEvent(GuiController.LoginUI.loginForgePass,function()
    {
        userInputUI.setVisible(true);
    },root);

    CocosHeler.setOnClickEvent(okBn,function()
    {
        //发送请求密码找回事件
        userInputUI.setVisible(false);
        GameGloble.g_webSocketClient.crossSendData("findpass",{ac:account.getString(),sj:shouji.getString()});
    },root);

    CocosHeler.setOnClickEvent(closeBn,function()
    {
        userInputUI.setVisible(false);
    },root);
    return messgeBox;
}

//初始化清理广告界面
GuiController.initClearAdsUI = function(root)
{
    var clearUI = root.getChildByName("ClearAdsUI");
    var clearBG = clearUI.getChildByName("BG");
    var clearBn = clearUI.getChildByName("ClearBn");
    var clearInfo = clearUI.getChildByName("InfoBn");
    var clearCloseBn = clearUI.getChildByName("Close");
    var clearAdBn = root.getChildByName("ClearAdsBn");//进入界面的按钮
    if(cc.sys.os == cc.sys.OS_IOS)
    {
        clearAdBn.setVisible(false);
    }
    CocosHeler.setOnClickEvent(clearAdBn,function()
    {
        clearUI.setVisible(true);
    },root);

    CocosHeler.setOnClickEvent(clearBG,function()
    {
        clearUI.setVisible(false);
    },root);
    CocosHeler.setOnClickEvent(clearCloseBn,function()
    {
        clearUI.setVisible(false);
    },root);

    CocosHeler.setOnClickEvent(clearBn,function()
    {
        NativeHelper.callNativeFunctionClearAds();
    },root);

    clearUI.setInfo = function(text)
    {
        clearInfo.setString(text);
    }
    cc.log("1");
    return clearUI;
}


