/**
 * Created by Administrator on 2015/8/20.
 */
window.io;

var SocketIO = SocketIO || window.io;
function GameNetWork(url,isNative)
{
    this.isConnected = false;
    this.checkIsConnectMask = false;
    this.needToCheckIsConnect = true;
    this.initAutoCheck = false;
    this.isNative = isNative;
    this.serverIP = url;
    this.isReconnectMode = false;//标识是否是重新连接的状态
    this.onError = false;

    this.onConnectEvent = new EventListenerManager(this);//连接成功事件
    this.onDisConnectEvent = new EventListenerManager(this);//连接失败事件
    this.onReconnectEvent = new EventListenerManager(this);
    //this.serverIP = "ws://123.56.140.219:18082";
    //this.serverIP = "ws://192.168.1.175:18082";
    this.client = SocketIO.connect(this.serverIP);
    if(isNative)
    {
        this.crossSendData = this.mobileSendData;
        this.crossParseData = this.mobileParseData;
    }
    else
    {
        this.crossSendData = this.htmlSendData;
        this.crossParseData = this.htmlParseData;
    }
    //this.autoDetecteIsConnect();
}

GameNetWork.onConnectEvent = new EventListenerManager(null);
GameNetWork.onDisConnectEvent = new EventListenerManager(null);
GameNetWork.onReconnectEvent = new EventListenerManager(null);

GameNetWork.prototype.initEvent = function(client,initFunc)
{
    var self = this;
    this.initFunc = initFunc;
    client.on("connect",function()
    {
        self.isConnected = true;
        if(self.isReconnectMode == false)
        {
            cc.log("第一次连接");
            //self.onConnectEvent.notifyEvent();
            GameNetWork.onConnectEvent.notifyEvent();
        }
        else
        {
            //重新连接模式
            cc.log("重新连接");
            GameNetWork.onReconnectEvent.notifyEvent();
        }
    });
    client.on("disconnect",function()
    {

    });
    client.on("error",function()
    {

    });
    client.on("hello",function()
    {
        cc.log("连着呢");
        self.checkIsConnectMask = true;
    });
    //initFunc(this.client,this);
}

//通过发送一个心跳包的方式进行监测，如果在1秒内还没有给答复，则认定为网络断开连接，重新进行连接
GameNetWork.prototype.checkAndReconnectServer = function()
{
    var self = this;
    this.checkIsConnectMask = false;
    g_GameNetWork.crossSendData("hello",{});
    GameGloble.LoginUI.schedule(function()
    {
        if(self.checkIsConnectMask == true)return;
        //失去连接了，重新连接
        self.isReconnectMode = true;
        GameNetWork.onDisConnectEvent.notifyEvent();
        try{
            //SocketIO.close();
            //self.client.disconnect();
        }catch(e){}
        //if(self.client){self.client.disconnect()};
        self.reconnectServer();
        cc.director.runScene(new LoginUIScene());
    },0,0,1);


    //cc.director.getScheduler().schedule(function()
    //{
    //    if(self.checkIsConnectMask == true)return;
    //    //失去连接了，重新连接
    //    self.isReconnectMode = true;
    //    self.onDisConnectEvent.notifyEvent();
    //    self.client.disconnect();
    //    self.reconnectServer();
    //},this,0,0,1);
}

GameNetWork.prototype.autoDetecteIsConnect = function()
{
    return;
    var self = this;
    this.needToCheckIsConnect = true;
    if(this.initAutoCheck == true)return;
    cc.director.getScheduler().schedule(function()
    {
        if(self.needToCheckIsConnect)self.checkAndReconnectServer();
    },this,5,Number.MAX_VALUE);
    this.initAutoCheck = true;
}
GameNetWork.prototype.stopDetecteIsConnect = function()
{
    this.needToCheckIsConnect = false;
}
GameNetWork.prototype.reconnectServer = function()
{
    var self = this;
    //this.client = SocketIO.connect(this.serverIP);
    var client  = SocketIO.connect(this.serverIP);
    this.initEvent(client,this.initFunc);
    //this.initEvent(this.initFunc);

    //g_GameNetWork = new GameNetWork(GameGloble.serverIP,cc.sys.isNative);
    //g_GameNetWork.initEvent((new GameNetWorkEventManager()).initEvent);
}

GameNetWork.prototype.crossSendData = null;
GameNetWork.prototype.crossParseData = null;

GameNetWork.prototype.mobileSendData = function(event,data)
{
    this.client.emit(event,JSON.stringify(data));
}

GameNetWork.prototype.mobileParseData = function(data)
{
    var json = JSON.parse(data);
    json = JSON.parse(json);
    //var realData = json.args;
    //realData = JSON.parse(realData[0]);
    return json;
}

GameNetWork.prototype.htmlSendData = function(event,data)
{
    this.client.emit(event,JSON.stringify(data));
}

GameNetWork.prototype.htmlParseData = function(data)
{
    return JSON.parse(data);
}




g_GameNetWork = null;