/**
 * Created by Administrator on 2016/1/15.
 */
function GameNetWorkEventManager()
{
    this.netWork = null;
    this.client = null;
}
GameNetWorkEventManager.prototype.initEvent = function(client)
{
    this.netWork = client;
    this.client = client;
    var self = this.client;
    var g_GameNetWork = GameGloble.g_webSocketClient;
    client.onReloginEvent = new EventListenerManager();

    client.on("connect",function(data)
    {

    });
    client.on("close",function(data)
    {

    });
    client.on("login",function(data)
    {
        data = self.crossParseData(data);
        if(data.rs == true)
        {
            cc.sys.localStorage.setItem("CanAutoLogin",1);
            cc.sys.localStorage.setItem("Account",GameGloble.UserAccount);
            cc.sys.localStorage.setItem("Pass",GameGloble.UserPass);
        }
        else if(data.rs == false)
        {
            cc.sys.localStorage.setItem("CanAutoLogin",0);
            GuiController.showWaitingUI(GuiController.LoginUI.waitingUI,'您输入的用户名或者密码有误！',2);
        }
    });

    client.on("relogin",function(data)
    {

        data = self.crossParseData(data);
        if(data.res == true)
        {
            cc.log("重新登录服务器成功!");
            GameGloble.UserAccount = data.pa;
            GameGloble.UserName = data.pn;
            GameGloble.NormalScore = data.ns;
            GameGloble.Chenghao = data.ch;
            GameGloble.LongNum = data.ln;
            GameGloble.LongGu = data.lg;
            GameGloble.HeadUrl = GameGloble.getHeadPath(data.phu);
            GameGloble.TableNums = data.tablenums;
            GameGloble.ClickAdNum = data.clickadnum;
            var isInGame = data.isingame;
            //发送重新登录的事件
            self.onReloginEvent.notifyEvent();
        }
        else
        {
            cc.director.end();
        }
    });


    client.on('register',function(data)
    {
        data = self.crossParseData(data);
        var LoginUI = GuiController.LoginUI;
        if(data.rs == true)
        {
            //提示注册成功，并显示登录界面
            GuiController.showWaitingUI(LoginUI.waitingUI,'恭喜您，注册成功！2秒后自动登录...！',2,function()
            {
                //登陆
                cc.sys.localStorage.setItem("CanAutoLogin",1);
                cc.sys.localStorage.setItem("Account",GameGloble.UserAccount);
                cc.sys.localStorage.setItem("Pass",GameGloble.UserPass);
                LoginUI.waitingUI.setVisible(true);
                self.crossSendData("login",{pa:GameGloble.UserAccount,ps:GameGloble.UserPass});
            });
        }
        else
        {
            cc.sys.localStorage.setItem("CanAutoLogin",0);
            var errType = data.type;
            if(errType == 1)
            {
                //提示注册失败
                GuiController.showWaitingUI(LoginUI.waitingUI,'账号已经被占用！',2);
            }
            else
            {
                //提示注册失败
                GuiController.showWaitingUI(LoginUI.waitingUI,'昵称已经被占用！',2);
            }

        }
    });

    //服务器返回玩家的信息
    client.on('entergame',function(data)
    {
        data = self.crossParseData(data);
        //服务器返回玩家的登录信息
        GameGloble.UserAccount = data.pa;
        GameGloble.UserName = data.pn;
        GameGloble.NormalScore = data.ns;
        GameGloble.Chenghao = data.ch;
        GameGloble.LongNum = data.ln;
        GameGloble.LongGu = data.lg;
        GameGloble.HeadUrl = GameGloble.getHeadPath(data.phu);
        GameGloble.ChenghaoHeadUrl = GameGloble.getChengHaoHeadUrl(data.phu,data.ch);//确定玩家实际使用的头像地址
        GameGloble.HallID = data.hallID;
        GameGloble.ClickAdNum = data.clickadnum;
        GameGloble.HallsTablesNums = data.hallTablesNums;
        GameGloble.HallsPlayerNums = data.hallPlayersNums;
        var isInGame = data.isingame;
        //进入玩法选择UI
        cc.director.runScene(new ChooseGameUIScene());
    });

    //获取大厅信息
    client.on('hallinfo',function(data)
    {
        data = self.crossParseData(data);
        GameGloble.GameType = 0;
        GameGloble.RankPlayerNums = data.ranknums;
        GameGloble.Longgu = data.longgu;
        GameGloble.HallsTablesNums = data.hallTableNums;
        GameGloble.HallsPlayerNums = data.hallPlayerNums;

        GuiController.ChooseGameUI.longguUI.setString(GameGloble.Longgu.toFixed(2));
        GuiController.ChooseGameUI.showInfo(GameGloble.HallsPlayerNums,GameGloble.RankPlayerNums);
    });

    client.on("checkcanenternormalgame",function(data)
    {
        data = self.crossParseData(data);
        var canEnter = data.canEnter;
        if(canEnter)
        {
            cc.director.runScene(new HallUIScene());
        }
        else
        {
            GuiController.showWaitingUI(GuiController.ChooseGameUI.waitingUI,data.message,3);
        }
    });

    //获取桌子信息，已经进入桌子的界面
    client.on("tableinfo",function(data)
    {
        data = self.crossParseData(data);
        var hallNum = data.tn;
        var datas = data.data;
        var hallID = data.hallID;

        for(var i = 0;i<datas.length;i++)
        {
            var posInfo = datas[i];;
            var headURL = GameGloble.getChengHaoHeadUrl(posInfo.phu,posInfo.ch);//根据称号选择的头像
            //显示玩家
            GuiController.HallUI.showOnePlayer(posInfo.pa,posInfo.pn,headURL,posInfo.tableid,posInfo.pos,posInfo.lt);
        }
        GuiController.HallUI.waitingUI.setVisible(false);
    });

    //玩家进入桌子事件
    client.on('playerintable',function(data)
    {
        data = self.crossParseData(data);
        var headURL = GameGloble.getChengHaoHeadUrl(data.phu,data.ch);//根据称号选择的头像
        GuiController.HallUI.showOnePlayer(data.pa,data.pn,headURL,data.tableid,data.pos,data.lt);
        GuiController.HallUI.waitingUI.setVisible(false);
    });

    //玩家被强制T出房间
    client.on("forceleavetable",function(data)
    {
        data = self.crossParseData(data);
        if(GameGloble.GameType != 1)
        {
            cc.director.runScene(new HallUIScene());
            return;
        }
        cc.director.runScene(new ChooseGameUIScene());
    });

    //玩家点击桌子，但是桌子有人
    client.on('tablehaveplayer',function(data)
    {
        GuiController.showWaitingUI(GuiController.HallUI.waitingUI,"位置已满!",2);
    });

    client.on('playerleavetable',function(data)
    {
        data = self.crossParseData(data);
        var account = data.pa;
        if(GameGloble.isMySelf(account))
        {
            //返回大厅
            return;
        }

        GuiController.HallUI.hideOnePlayer(account);
    });

    client.on("gametableprepareinfo",function(data)
    {
        data = self.crossParseData(data);
        for(var key in data.infos)
        {
            var info = data.infos[key];
            //var headURL = GameGloble.getHeadPath(info.phu);
            var headURL = GameGloble.getChengHaoHeadUrl(info.phu,info.ch);
            GuiController.GameUI.playerEnterTalbe(info.ac,info.pos,info.pn,headURL,info.lt,info.ip,info.ch);
        }
    });

    client.on('preparestate',function(data)
    {
        data = self.crossParseData(data);
        var GameUI =  GuiController.GameUI;
        if(GameUI == null)return;
        var screenPos = GuiController.GameUI.getScreenPos(data.pos);
        GuiController.GameUI.setPrePare(screenPos,data.ip);
    });

    //进入发牌阶段
    client.on("enterdealcard",function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameGloble.IsPlaying = true;
        //隐藏准备的手
        GameUI.clearUI();
        GameUI.clearPrePare();
        GameUI.hideHeadAndName("bottom");
        GameUI.hideChenghao(GameGloble.Pos);

        //显示比分数字
        GameUI.showBifenUI();
        GameUI.playingState = 1;
        GameUI.keyNum = data.keynum;
        GameUI.canLeaveRank = false;
        var bifen = data.bifen[GameGloble.Pos];
        GameUI.showBifenText(bifen.wofangHitNum,bifen.duifangHitNum);
        GameUI.showRemainJuNum(data.ju);//显示剩下的局数
        if(data.ft == false)//不是第一局开局
        {
            //GameData.GameUI.showBeginGameInfo()
            //显示比赛信息
        }

        //播放游戏背景声音
        g_SoundManager.playGameBackGround();
    });

    //服务器发牌
    client.on("dealcard",function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        var cardIndex = data.ci;
        GameUI.addOneHandCardIndex(cardIndex);
        GameUI.repositionCardsNormal();
        GameUI.hideTextTip();
        //播放发牌的声音
        g_SoundManager.playDealCardSound();
    });

    //定主
    client.on('makemain',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.makeMain(data.pos,data.ci);
        GameUI.showHitCards(data.pos,[53,data.ci]);

        //在界面的顶端显示主信息
        GameUI.showTopZhuIcon();
        //定主的玩家说话
        GameUI.showTalk(data.pos,"定主",4);
        g_SoundManager.playDingzhu(GameGloble.getPlayerSex(GameUI.getPlayerHeadUrl(data.pos)));
    });



    client.on("askfanzhu",function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        if(GameGloble.isMyPos(data.pos) == true)
        {
            GameUI.showTimeOutUI(data.pos,10,function()
            {
                GameUI.hideFanzhuUI();
            });
            GameUI.showFanzhuUI();
        }
        else
        {
            GameUI.showTextTip("等待其他玩家是否反主...");
        }
    });

    client.on('fanzhutimeout',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        if(GameGloble.isMyPos(data.pos))
        {
            GameUI.hideTimeOut();
            GameUI.hideFanzhuUI();
        }
        GameUI.hideTextTip();
    });

    client.on('fanzhu',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.makeMain(data.pos,data.ci);;
        GameUI.showZhuang(data.pos);
        GameUI.hideTextTip();

        //在当前出牌的位置，显示反主的信息
        var hitCards = [];
        for(var i = 0;i<data.kn;i++)
        {
            hitCards.push(53);
        }
        hitCards.push(data.ci);

        GameUI.showHitCards(data.pos,hitCards);
        GameUI.showTalk(data.pos,"反主",4);
        g_SoundManager.playFanzhu(GameGloble.getPlayerSex(GameUI.getPlayerHeadUrl(data.pos)));
        //玩家说反主
        //GameData.GameUI.showTalk(data.pos,"反主");
        //播放反主的声音
    });

    client.on("remaincard",function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;


        if(GameGloble.isMyPos(data.pos))
        {
            for(var key in data.rm)
            {
                var index = data.rm[key];
                GameUI.addOneHandCardIndex(index);
            }
            GameUI.showTimeOutUI(GameGloble.Pos,45);
            GameUI.showKoudiUI();
        }
        GameUI.playingState = 2;
        GameUI.showZhufuPlane();
        GameUI.showYaoxingUI();
        GameUI.repositionCardsNormal();
        GameUI.showKandiBn();
        GameUI.fillRemaincards(data.rm);
    });

    client.on('remaincardrespond',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        var cards = data.rm;
        GameUI.dicards = cards;
        for(var key in cards)
        {
            var oneIndex = cards[key];
            GameUI.removeOneHandCardIndex(oneIndex);
        }
        GameUI.lastSelectType = null;
        GameUI.repositionCardsNormal();
        GameUI.unselectHandCard();
        GameUI.fillPlayerRemainCards(data.rm);
    });

    client.on('remaincardtimeout',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.dicards = data.rm;
        GameUI.hideTimeOut();
        GameUI.hideKoudiUI()
        for(var key in data.rm)
        {
            var cardIndex = data.rm[key];
            GameUI.removeOneHandCardIndex(cardIndex);
        }
        GameUI.lastSelectType = null;
        GameUI.repositionCardsNormal();
        GameUI.unselectHandCard();
        GameUI.fillPlayerRemainCards(data.rm);
    });

    client.on('zhaixing',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;

        GameUI.showTimeOutUI(GameGloble.Pos,25);
        GameUI.showYaoxingUI();

        var kingNum = GameUI.getKingNum();
        if(kingNum == 0)
        {
            //发送给服务器回复
            GameUI.showTextTip('等待其他玩家扣底和栽星操作...');
            self.crossSendData('zhaixing',{zx:0});
            return;
        }
        GameUI.showZhaixingUI();
    });

    //要星事件
    client.on('yaoxing', function (data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        var yaoxing = data.yx;
        var yaoxingPos = data.pos;
        if(yaoxing == true)
        {
            //对家，我牌挺好的，摘上哇
            GameUI.showTalk(yaoxingPos,"对家，我牌挺好的，栽上哇!",4);
        }
        else
        {
            //不顶，我拍不好，不要
            GameUI.showTalk(yaoxingPos,"不顶，我牌不好，不要!",4);
        }
    });

    client.on('yaoxingtimeout',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.hideYaoxingUI();
    });

    client.on('zhaixingtimeout',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.hideZhaixingUI();
        GameUI.hideTimeOut();
        GameUI.showTextTip("等待其他玩家扣底和栽星操作...");
    });

    //更换牌
    client.on('changecard',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;

        var changeCardData = data.changecard;
        for(var key in changeCardData)
        {
            var oneData = changeCardData[key];
            var pos = oneData.pos;
            var kingNum = oneData.kn;

            GameUI.showZhaixingPlane(pos,kingNum);
            GameUI.showTalk(pos,"栽"+kingNum+"个王子",4);

            if(!GameGloble.isMyPos(pos))continue;

            GameUI.unselectHandCard();
            for(var kingKey in oneData.ki)
            {
                var oneKing = oneData.ki[kingKey];
                GameUI.removeOneHandCardIndex(oneKing);
            }
            for(var changeKey in oneData.ccs)
            {
                var oneChangeCard = oneData.ccs[changeKey];
                GameUI.addOneHandCardIndex(oneChangeCard);
            }
            GameUI.repositionCardsNormal();
        }
        GameUI.fillPlayerRemainCards(data.dcs);
    });

    client.on('playerkoudi',function(data)
    {
        return;
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        var dicards = data.dcs;
        GameUI.fillPlayerRemainCards(dicards);
        //GameData.GameUI.showKoudi(dicards);
    });

    client.on('enterhitcard',function(data)
    {
        //隐藏提示
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.playingState = 3;
        GameUI.hideTextTip();
        GameUI.showZhufuPlane();
        GameUI.clearHitCardPlane();
        GameUI.shanglunBn.setVisible(true);
    });

    client.on('truntohitcard',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.hideTimeOut();
        GameUI.turnToHitCard(data.pos);
        if(GameGloble.isMyPos(data.pos))
        {
            GameUI.isFirstHitCard = data.if;
            GameUI.hitMarsk = data.hitmarsk;
            cc.log("出牌的标记"+GameUI.hitMarsk);
            var serverHandCards = data.handcards;
            //检测并重置手里的牌
            GameUI.checkAndResetHandCards(serverHandCards);
            //按照牌的类型展开牌,提示玩家
            if(GameUI.isFirstHitCard != true)
            {
                //得到本局需要出的牌类型,然后根据本局的牌类型进行提示
                var tempCardIndex = GameUI.firstHitCards[0];
                var tempType = GameHelper.getCardType(tempCardIndex,GameUI.keyNum,GameUI.mainType);
                if(tempType == GameUI.lastSelectType)return;
                GameUI.expandCardUIS(tempType);
            }
        }
    });

    client.on('hitcard',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        if(data.if == true)
        {
            GameUI.lastHitCards = GameUI.currentHitCards;
            GameUI.currentHitCards = {};
            //清空客户端的出牌
            GameUI.clearHitCardPlane();
            //记录第一次出的牌
            GameUI.firstHitCards = data.hcs;
            GameUI.firstHitCardPos = data.pos;

            GameUI.lastSelectType = null;
            var cardType = GameHelper.getCardType(GameUI.firstHitCards[0],GameUI.keyNum,GameUI.mainType);
            GameUI.expandCardUIS(cardType);
        }
        if(GameGloble.isMyPos(data.pos))
        {
            GameUI.hideHitCardUI();
            GameUI.clearTipCards();
            GameUI.removeHandCardIndexsAndReposition(data.hcs);
            GameUI.unselectHandCard();
            GameUI.lastSelectType = null;
            var cardType = GameHelper.getCardType(data.hcs[0],GameUI.keyNum,GameUI.mainType);
            GameUI.expandCardUIS(cardType);
        }
        //else
        //{
        //    var cardType = GameHelper.getCardType(GameUI.firstHitCards[0],GameUI.keyNum,GameUI.mainType);
        //    GameUI.expandCardUIS(cardType);
        //}
        GameUI.currentHitCards[data.pos] = data.hcs;//用来保存上手牌

        GameUI.hideTimeOut();
        GameUI.showHitCards(data.pos,data.hcs);
        GameUI.showBigIcon();
        if(GameUI.showShaIcon(data.pos))return;//如果杀了的话，就不播放出牌的声音了
        //播放出牌声音
        var headKey = GameUI.getPlayerHeadUrl(data.pos);
        g_SoundManager.playHitCardSound(GameGloble.getPlayerSex(headKey),data.hcs);
    });

    client.on('eatscore',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        var score = data.sc;
        GameUI.eatScore(score,GameUI.getHitCardsScoreIndexs());
    });

    client.on('junum',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        var ju = data.juNum;
        var finish = data.finish;
    });

    client.on('score',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.winScoreData = data.score;
        GameUI.showGetScoreFinishUI( GameUI.winScoreData );
    });

    client.on("leavelosescore",function(data)
    {
        data = self.crossParseData(data);
        var leaveScore = data.score;
        //在当前的界面显示出玩家离开了，扣除了一定分数的龙骨
        try
        {
            GuiController.CurrentUI.normalMessage.showNormalMessage("您中途退出游戏，扣除"+leaveScore+"龙骨");
        }
        catch(e)
        {

        }
    });

    client.on('LongGuScore',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.winLongGuData = data.score;
        if(data.normal == false)
        {
            //直接显示龙骨得分
        }
    });

    client.on("playerkoudi",function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.showDifen = true;
        GameUI.difen = data.df;
        GameUI.dicards = data.dcs;

    });

    client.on('nextgame',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameGloble.IsPlaying = false;
        var dadiPos = data.dp;
        var keyNum = data.kn;
        var mainType = data.mt;
        var bifen = data.bf;
        var isJuFinish = data.jufinish;//是否局结束了
        GameUI.playingState = 0;//设置当前状态为准备前状态
        try
        {
            if(GameUI.showDifen == true)//显示底牌吃分
            {
                GameUI.showFinishDipaiUI(GameUI.dicards);
                GameUI.eatScore(GameUI.difen,GameUI.getDiCardsScoreIndexs());
                GameUI.schedule(function()
                {
                    GameUI.hideFinishDipaiUI();
                    if(GameUI.playingState != 0)return;
                    if(GameGloble.GameType == 1)
                    {
                        GameUI.showLongGuFinishUI(GameUI.winLongGuData);
                        GameUI.schedule(function()
                        {
                            if(isJuFinish == true)
                            {
                                GameUI.showPlayerLeaveOrStaUI(0);
                                GameUI.resetUI();
                            }
                            else
                            {
                                GameUI.nextGame(dadiPos,keyNum,mainType,bifen);
                            }

                        },0,0,2);

                    }
                    else
                    {
                        GameUI.showGetScoreFinishUI(GameUI.winScoreData);
                        GameUI.nextGame(dadiPos,keyNum,mainType,bifen);
                    }

                },0,0,4);
            }
            else
            {

                if(GameGloble.GameType == 1)
                {
                    GameUI.showLongGuFinishUI(GameUI.winLongGuData);
                    GameUI.schedule(function()
                    {
                        if(GameUI.playingState != 0)return;
                        if(isJuFinish == true)
                        {
                            GameUI.showPlayerLeaveOrStaUI(0);
                            GameUI.resetUI();
                        }
                        else
                        {
                            GameUI.nextGame(dadiPos,keyNum,mainType,bifen);
                        }

                    },0,0,2);
                }
                else
                {
                    GameUI.showGetScoreFinishUI(GameUI.winScoreData);
                    GameUI.nextGame(dadiPos,keyNum,mainType,bifen);
                }
            }
        }
        catch(e)
        {
            GameUI.hideFinishDipaiUI();
            GameUI.nextGame(dadiPos,keyNum,mainType,bifen);
        }
    });

    client.on('restart',function(data)
    {
        data = self.crossParseData(data);
        GameGloble.IsPlaying = false;
        var GameUI = GuiController.GameUI;
        if(GameGloble.GameType == 1)return;//龙骨赛，重置游戏的途径是完成一轮和完成了规定的局数
        GameUI.resetUI();
    });

    client.on('LongGuFinishOneCircle',function(data)
    {
        data = self.crossParseData(data);
        GameGloble.IsPlaying = false;
        var GameUI = GuiController.GameUI;
        GameUI.winLongGuData  = data.scoredata;
        var powerUpData = data.powerup;
        GameUI.canLeaveRank = true;
        if(GameUI.showDifen == true)//显示底牌吃分
        {
            GameUI.showFinishDipaiUI(GameUI.dicards);
            GameUI.eatScore(GameUI.difen,GameUI.getDiCardsScoreIndexs());
            GameUI.schedule(function()
            {
                GameUI.hideFinishDipaiUI();
                GameUI.showLongGuFinishUI(GameUI.winLongGuData);
                GameUI.schedule(function()
                {
                    GameUI.showPlayerLeaveOrStaUI(1);
                    GameUI.showPowerUpUIWithData(powerUpData);
                    GameUI.resetUI();
                },0,0,2);
            },0,0,4);
        }
        else
        {
            GameUI.showLongGuFinishUI(GameUI.winLongGuData);
            GameUI.schedule(function()
            {
                GameUI.showPlayerLeaveOrStaUI(1);
                GameUI.showPowerUpUIWithData(powerUpData);
                GameUI.resetUI();
            },0,0,2);
        }

    });

    client.on("NormalFinishOneCircle",function(data)
    {
        data = self.crossParseData(data);
        GameGloble.IsPlaying = false;
        var GameUI = GuiController.GameUI;
        var powerUpData = data.powerup;
        if(GameUI.showDifen == true)//显示底牌吃分
        {
            GameUI.showFinishDipaiUI(GameUI.dicards);
            GameUI.eatScore(GameUI.difen,GameUI.getDiCardsScoreIndexs());
            GameUI.schedule(function()
            {
                GameUI.hideFinishDipaiUI();
                GameUI.schedule(function()
                {
                    GameUI.showPlayerLeaveOrStaUI(1);
                    GameUI.showPowerUpUIWithData(powerUpData);
                    GameUI.resetUI();
                },0,0,0.3);
            },0,0,4);
        }
        else
        {
            GameUI.schedule(function()
            {
                GameUI.showPlayerLeaveOrStaUI(1);
                GameUI.showPowerUpUIWithData(powerUpData);
                GameUI.resetUI();
            },0,0,0.3);
        }
    });

    client.on("tucao",function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        var index = data.index;

        var ss = GameUI.getTuCaoString(index);
        GameUI.showTalk(data.pos,ss,3);
        g_SoundManager.playTuCao(GameGloble.getPlayerSex(GameUI.getPlayerHeadUrl(data.pos)),index);
    });


    client.on('playeringametable',function(data)
    {
        data = self.crossParseData(data);
        //var headUrl = GameGloble.getHeadPath(data.phu);
        var headUrl = GameGloble.getChengHaoHeadUrl(data.phu,data.ch);
        GuiController.GameUI.playerEnterTalbe(data.ac,data.pos,data.pn,headUrl,data.lt,data.ip,data.ch);
    });

    client.on('playerleavegametable',function(data)
    {
        data = self.crossParseData(data);
        if(GameGloble.isMyPos(data.pos))return;
        GuiController.GameUI.playerLeaveTable(data.pos,data.ip);

        //GameData.GameScorePlaneUI.requestInfo();
    });

    client.on('tuoguan',function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        var pos = data.pos;
        var isTuoguan = data.it;
        GameUI.showTuoGuan(pos,isTuoguan);
    });

    //获取玩家基本信息
    client.on("questuserinfo",function(data)
    {
        data = self.crossParseData(data);
        GuiController.ChooseGameUI.baseInfoUI.showInfo(GameGloble.HeadUrl,GameGloble.UserName,data.longgu,data.longnum,data.chenghao,data.paiming);
    });

    //在玩牌的时候点击玩家的头像，获取信息
    client.on("askplayerinfo",function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.showPlayerInfo(data.pos,data);
    });

    client.on("getrankinfo",function(data)
    {
        data = self.crossParseData(data);
        var chooseRankUI = GuiController.ChooseRankUI;
        chooseRankUI.showRankItems(data);
    });

    client.on("startrank",function(data)
    {
        data = self.crossParseData(data);
        var tableID = data.tableid;
        var pos = data.pos;
        GameGloble.Pos = pos;
        GameGloble.TableID = tableID;
        GameGloble.GameType = 1;//龙骨比赛
        cc.director.runScene(new GameUIScene());
    });

    client.on("playerleaverank",function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        if(GameUI == null){cc.director.runScene(new ChooseGameUIScene());return};
        GameUI.showLongGuFinishUI(data);
        GameUI.schedule(function()
        {
            //显示玩家离开UI
            GameUI.showPlayerLeaveRankUI(0);
        },0,0,3);
    });

    //玩家在等待界面的消息,用来接收正在等待的玩家数量
    client.on('rankplayernum',function(data)
    {
        data = self.crossParseData(data);
        var rankNum = data.ranknum;
        var chooseRankUI = GuiController.ChooseGameUI;
        chooseRankUI.showWaitingUIWaitingNum(rankNum);
    });

    //验证玩家是否能进入比赛的凭据
    client.on("canenterrank",function(data)
    {
        data = self.crossParseData(data);
        var can = data.can;
        var rankUI = GuiController.ChooseGameUI;
        rankUI.waitingUI.setVisible(false);
        var enterchenghao = data.enterchenghao;
        var enterlonggu = data.enterlonggu;
        var longgu = data.longgu;
        var enterLongnum = data.enterLongnum;
        if(can == false)
        {
            GameGloble.LongGu = longgu;
            rankUI.showCanNotEnterInfo(enterchenghao,enterlonggu,enterLongnum);
        }
        else
        {
            rankUI.enterRank();
        }
    });

    client.on("longgunot",function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        for(var key in data)
        {
            var pos = key;
            var name = data[key].name;
            var account = data[key].account;

            if(GameGloble.isMyPos(pos))
            {
                //显示龙骨数量小于0,现在充值，返回大厅
                GameUI.showLongguBuZuUI();
                return;
            }
            else
            {
                //显示有玩家龙骨不足，3秒后自动离开
                GameUI.showPlayerLeaveRankUI(1);
                return;
            }
        }
    });


    client.on("playeroffline",function(data)
    {
        data = self.crossParseData(data);
        var GameUI = GuiController.GameUI;
        GameUI.showDuanxian(data.pos,data.offline);
    });

    client.on("reconnectrankgame",function(data)
    {

        data = self.crossParseData(data);
        //设置全局的信息
        GameGloble.TableID = data.tableID;
        GameGloble.GameType = data.gametype;
        GameGloble.IsPlaying = data.isplaying;
        GameGloble.Pos = data.playerpos;
        GameGloble.reConnectData = data;
        if(GameGloble.IsPlaying)g_SoundManager.playGameBackGround();
        cc.director.runScene(new GameUIScene());
    });

    client.on("reconnectnormalgame",function(data)
    {
        data = self.crossParseData(data);
        //设置全局的信息
        GameGloble.TableID = data.tableID;
        GameGloble.GameType = data.gametype;
        GameGloble.IsPlaying = data.isplaying;
        GameGloble.Pos = data.playerpos;
        GameGloble.reConnectData = data;
        if(GameGloble.IsPlaying)g_SoundManager.playGameBackGround();
        cc.director.runScene(new GameUIScene());
    });
    client.on("playertalk",function(data)
    {
        data = self.crossParseData(data);
        var talkString = data.talk;
        var pos = data.pos;
        var GameUI = GuiController.GameUI;
        GameUI.showTalk(pos,talkString,3);
    });

    client.on("findpass",function(data)
    {
        try
        {
            data = self.crossParseData(data);
            var passString = data.pass;
            GuiController.LoginUI.findPassWordUI.showFindPassWord(passString);
        }
        catch(e)
        {
            cc.log("错误");
        }
    });
}