/**
 * Created by Administrator on 2015/8/27.
 */

var GameUILayer = cc.Layer.extend({
    sprite:null,
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        GuiController.GameUI = this;
        GuiController.CurrentUI = this;
        g_GameNetWork = GameGloble.g_webSocketClient;
        var self = this;
        var mainScene = ccs.load(res.GameUI);
        this.action = mainScene.action;
        this.sceneNode = mainScene.node
        this.addChild(this.sceneNode);

        //播放开始动画
        CocosHeler.runSceneAnimation(this.sceneNode,this.action,"StartAnimation",true);

        this.uiMap = {top:{},left:{},bottom:{},right:{}};
        this.posIndex = {top:0,left:1,bottom:2,right:3};
        this.numPosIndex = {0:'top',1:'left',2:'bottom',3:'right'};

        this.mainType = 4;//本局打的花色
        this.keyNum = 3;//本局打几
        this.dadiPos = "bottom";//打底玩家的位置

        this.topZIndex = 10000;
        this.frontZIndex = 0;

        this.dicards = [];//底牌

        this.selectCardUIs = [];//玩家选中的牌

        this.isFirstHitCard = false;//自己是不是第一个出牌
        this.firstHitCards = [];//每一轮第一次出的牌
        this.firstHitCardPos = "bottom";

        this.haveTipIndexs = false;
        this.tipCards = [];
        this.tipIndex = 0;

        this.playingState = 0;//0准备，1代表发牌阶段，2代表扣底阶段,3代表出牌阶段

        this.totalEatScoreNum = 0;//吃分总数

        this.showDifen = false;//是否显示底的分数
        this.difen = 0;//底牌的分数

        this.winScoreData = null;
        this.winLongGuData = null;

        this.canLeaveRank = false;//可以离开比赛吗
        this.hitMarsk = 0;//出牌标记

        this.lastHitCards = {"left":[],"top":[],"right":[],"bottom":[]};
        this.currentHitCards = {"left":[],"top":[],"right":[],"bottom":[]};
        //准备按钮
        this.prepareBn = this.sceneNode.getChildByName("PrepareBn");
        CocosHeler.setOnClickEvent(this.prepareBn,function()
        {
            this.prepareBn.setVisible(false);
            this.prepareBnTipInfo.setVisible(false);
            this.clearUI();
            g_GameNetWork.crossSendData('preparestate',{ip:true});
            g_SoundManager.playHitMenuSound();
            //不显示Banner广告
            Ads.hideGDTBanner()
        },this);
        this.prepareBnTipInfo = this.sceneNode.getChildByName("PrepareBnTipInfo");
        if(GameGloble.GameType != 1)//如果是排位赛，第一次进入，不需要显示准备
        {
            this.showPrepareInfo();
        }

        //上轮按钮
        this.shanglunBn = this.sceneNode.getChildByName("Shanglun_Bn");
        this.shanglunUI = this.sceneNode.getChildByName("ShangLunUI");
        this.shanglunUIClose = this.shanglunUI.getChildByName("CloseBn");
        //点击上轮按钮
        CocosHeler.setOnClickEvent(this.shanglunBn,function()
        {
            this.showShangshoupaiUI(this.lastHitCards);
        },this);
        CocosHeler.setOnClickEvent(this.shanglunUIClose,function()
        {
            this.shanglunUI.setVisible(false);
        },this);


        //退出房间按钮
        this.quitGameBn = this.sceneNode.getChildByName("QuitGame");
        this.messageBox = GuiController.initMessageBox(this.sceneNode.getChildByName("MessageBox"),"离开房间?",function()
        {
            g_SoundManager.playHitMenuSound();
            g_GameNetWork.crossSendData('playerleavetable',{});
            if(GameGloble.GameType == 1)
            {
                cc.director.runScene(new ChooseGameUIScene());
            }
            else
            {
                cc.director.runScene(new HallUIScene());
            }
        },function()
        {
            Ads.hideGDTBanner();
            g_SoundManager.playHitMenuSound();
        });

        CocosHeler.setOnClickEvent(this.quitGameBn,function()
        {
            g_SoundManager.playShowMenuSound();
            this.messageBox.showMessageBox();
            //显示Banner
            Ads.showGDTBanner();
        },this);

        //点击设置UI
        GuiController.initGameSetUI(this.sceneNode);

        //--------------------------比分--------------------------
        this.bifenLeft = this.sceneNode.getChildByName("BifenLeft");
        this.bifenLeft.setString(3);
        this.bifenImage = this.sceneNode.getChildByName("BifenImage");
        this.bifenRight = this.sceneNode.getChildByName("BifenRight");
        this.bifenRight.setString(3);
        //--------------------------吃分--------------------------
        this.chiFenNum = this.sceneNode.getChildByName("EatScore");
        this.chiFenNum.setString(0);
        this.chiFenPlane = this.sceneNode.getChildByName("EatScorePlane");
        this.chiFenPlaneTop = this.chiFenPlane.getChildByName("TopPlane");
        this.chifenPlaneBottom = this.chiFenPlane.getChildByName("BottomPlane");

        this.eatScoreAnimationUI = this.sceneNode.getChildByName("EatScoreAnimationUI");
        this.eatScoreAddMark = this.eatScoreAnimationUI.getChildByName("AddMark");
        this.eatScoreNum1 = this.eatScoreAnimationUI.getChildByName("Num1");
        this.eatScoreNum2 = this.eatScoreAnimationUI.getChildByName("Num2");
        this.fenshuDabiao = this.sceneNode.getChildByName("FenshuDabiao");
        this.eatScoreAction = CocosHeler.connectAction(this.eatScoreAnimationUI,res.EatScoreUIAction);

        //--------------------------上面的主类型------------------------
        this.topZhuType = this.sceneNode.getChildByName("topZhuTyp");
        this.topZhuText = this.sceneNode.getChildByName("topZhuName");

        //--------------------------上面的还剩多少局
        this.juNumText2 = this.sceneNode.getChildByName("JuNumText2");//十位
        this.juNumText1 = this.sceneNode.getChildByName("JuNumText1");//个位
        this.juNumImage = this.sceneNode.getChildByName("JuNumImage");
        this.topBisaiImage = this.sceneNode.getChildByName("topBisaiImage");
        this.topEndImage = this.sceneNode.getChildByName("topEndImage");

        //--------------------------反主-----------------------------
        this.fanzhu = this.sceneNode.getChildByName("Fanzhu");
        CocosHeler.setOnClickEvent(this.fanzhu,function()
        {
            self.hideFanzhuUI();
            self.hideTimeOut();
            g_GameNetWork.crossSendData('askfanzhu',{fr:true});
            g_SoundManager.playClickMenuSound();
        },this);
        this.bufanzhu = this.sceneNode.getChildByName("Bufanzhu");
        CocosHeler.setOnClickEvent(this.bufanzhu,function()
        {
            self.hideFanzhuUI();
            self.hideTimeOut();
            g_GameNetWork.crossSendData('askfanzhu',{fr:false});
            g_SoundManager.playClickMenuSound();
        },this);
        //---------------------------扣抵----------------------------
        this.koudi = this.sceneNode.getChildByName("Koudi");
        CocosHeler.setOnClickEvent(this.koudi,function()
        {
            g_SoundManager.playClickMenuSound();
            if(this.selectCardUIs.length !=6)
            {
                //提示，底牌需要扣6张
                this.showImageTip("已选"+this.selectCardUIs.length+"张,需要6张",1);
                return;
            }
            //从界面上移除这几张牌
            this.showTextTip('等待其他玩家完成栽星操作...');
            var selectCardIndexArray = [];
            for(var key in this.selectCardUIs)
            {
                var oneCardUI = this.selectCardUIs[key];
                selectCardIndexArray.push(oneCardUI.index);
            }
            g_GameNetWork.crossSendData('remaincard',{rc:selectCardIndexArray});
            this.selectCardUIs = [];
            this.hideKoudiUI();
            this.hideTimeOut();
        },this);

        //----------------------------要星---------------------------
        this.yaoxing = this.sceneNode.getChildByName("Yaoxing");
        CocosHeler.setOnClickEvent(this.yaoxing,function()
        {
            this.hideYaoxingUI();
            g_GameNetWork.crossSendData("yaoxing",{yx:true});
            g_SoundManager.playClickMenuSound();
        },this);
        this.buyaoxing = this.sceneNode.getChildByName("Buyaoxing");
        CocosHeler.setOnClickEvent(this.buyaoxing,function()
        {
            this.hideYaoxingUI();
            g_GameNetWork.crossSendData("yaoxing",{yx:false});
            g_SoundManager.playClickMenuSound();
        },this);

        //----------------------------摘星---------------------------
        this.buzhaixing = this.sceneNode.getChildByName("Buzhaixing");
        this.zhaixing1 = this.sceneNode.getChildByName("Zhaixing1");
        this.zhaixing2 = this.sceneNode.getChildByName("Zhaixing2");
        this.zhaixing3 = this.sceneNode.getChildByName("Zhaixing3");

        CocosHeler.setOnClickEvent(this.buzhaixing,function()
        {
            this.showTextTip('等待其他玩家扣底和栽星操作...');
            this.hideZhaixingUI();
            this.hideTimeOut();
            g_GameNetWork.crossSendData('zhaixing',{zx:0});
            g_SoundManager.playClickMenuSound();

        },this);

        CocosHeler.setOnClickEvent(this.zhaixing1,function()
        {
            this.showTextTip('等待其他玩家扣底和栽星操作...');
            this.hideZhaixingUI();
            this.hideTimeOut();
            g_GameNetWork.crossSendData('zhaixing',{zx:1});
            g_SoundManager.playClickMenuSound();
        },this);

        CocosHeler.setOnClickEvent(this.zhaixing2,function()
        {
            this.showTextTip('等待其他玩家扣底和栽星操作...');
            this.hideZhaixingUI();
            this.hideTimeOut();
            g_GameNetWork.crossSendData('zhaixing',{zx:2});
            g_SoundManager.playClickMenuSound();
        },this);

        CocosHeler.setOnClickEvent(this.zhaixing3,function()
        {
            this.showTextTip('等待其他玩家扣底和栽星操作...');
            this.hideZhaixingUI();
            this.hideTimeOut();
            g_GameNetWork.crossSendData('zhaixing',{zx:3});
            g_SoundManager.playClickMenuSound();
        },this);

        //----------------------------提示和出牌------------------------
        this.tipCardBn = this.sceneNode.getChildByName("TipCardBn");
        this.hitCardBn = this.sceneNode.getChildByName("HitCardBn");
        CocosHeler.setOnClickEvent(this.tipCardBn,function()
        {
            g_SoundManager.playClickMenuSound();
            var cardIndexs = [];
            var childs = this.handCardPlane.getChildren();
            for(var key in childs)
            {

                cardIndexs.push(childs[key].index);
            }
            if(this.haveTipIndexs == false)
            {
                this.tipCards =  GameHelper.tipCards(this.isFirstHitCard,cardIndexs,this.firstHitCards[0],this.firstHitCards.length,this.mainType,this.keyNum);
                this.haveTipIndexs = true;
                this.tipIndex = 0;
            }

            this.unselectHandCard();
            var canHitCards = this.tipCards[this.tipIndex];
            this.tipIndex+=1;
            for(var key in canHitCards)
            {
                var popCardIndex = canHitCards[key];
                this.autoSelectOrUnselectCard(this.getCardUIWithIndex(popCardIndex));
            }
            if(this.tipIndex>this.tipCards.length-1)
            {
                this.tipIndex = 0;
            }
        },this);
        CocosHeler.setOnClickEvent(this.hitCardBn,function()
        {
            g_SoundManager.playClickMenuSound();
            if(this.checkCanHitCard() == false)
            {
                //提示不满足出牌规则
                this.showImageTip("您出的牌不满足出牌规则!",2.5);
                return;
            }
            var selectCardIndex = [];
            for(var key in this.selectCardUIs)
            {
                var oneCardUI = this.selectCardUIs[key];
                selectCardIndex.push(oneCardUI.index);
            }
            g_GameNetWork.crossSendData('hitcard',{hcs:selectCardIndex,hitmarsk:this.hitMarsk});
            this.hideTimeOut();
            this.hideHitCardUI();
        },this);

        //----------------------------看底------------------------------
        this.kandi = this.sceneNode.getChildByName("KandiBn");
        this.kandiUI = this.sceneNode.getChildByName("KandiUI");
        this.kandUiDiCardsPlane = this.kandiUI.getChildByName("BG").getChildByName("DiCardsPlane");
        this.kandUIPlayerCardsPlane = this.kandiUI.getChildByName("BG").getChildByName("PlayerDiCardsPlane");
        this.kandiUIClose = this.kandiUI.getChildByName("BG").getChildByName("Close");
        CocosHeler.setOnClickEvent(this.kandi,function()
        {
            g_SoundManager.playClickMenuSound();
            this.showKandiUI();
        },this);

        CocosHeler.setOnClickEvent(this.kandiUIClose,function()
        {
            this.hideKandiUI();
        },this);

        //----------------------------下面的主类型-----------------------
        this.bottomZhuType = this.sceneNode.getChildByName("bottomZhuType");
        this.bottomZhuNum = this.sceneNode.getChildByName("bottomZhuNum");
        this.bottomZhuD = this.sceneNode.getChildByName("bottomZhuD");

        //------------------------------提示信息----------------------------
        this.tipText = this.sceneNode.getChildByName("TipText");
        this.tipImage = this.sceneNode.getChildByName("InfoBg");
        this.tipImageText = this.tipImage.getChildByName("InfoText");


        //-------------------------牌面板------------------------------
        this.handCardPlane = this.sceneNode.getChildByName("HandCardPlane");
        this.setUpSelectCardEvent();//出牌面板的事件


        //------------------------最终得分----------------------------------
        this.showGetScoreUI = this.sceneNode.getChildByName("ShowGetScoreUI");
        this.showGetScoreUI.setVisible(false);
        var BG = this.showGetScoreUI.getChildByName("BG");
        this.showGetScoreAnimation = CocosHeler.connectAction(this.showGetScoreUI,res.ShowGetScoreAction);
        this.showGetScoreWinUI = BG.getChildByName("Win");
        this.showGetScoreLoseUI = BG.getChildByName("Lose");
        this.showGetScorePingUI = BG.getChildByName("Ping");
        this.showGetScoreCloseBn = BG.getChildByName("Close");
        CocosHeler.setOnClickEvent(this.showGetScoreCloseBn,function()
        {
            this.showGetScoreUI.setVisible(false);
        },this);


        //-------------------------吐槽界面-----------------------------------
        var self = this;
        this.tucaoTimeOut = true;
        this.tucaoUI = this.sceneNode.getChildByName("TuCaoUI");
        this.tucaoUI.isShowing = false;
        this.tucaoAction = CocosHeler.connectAction(this.tucaoUI,res.TuCaoUIAction);
        var clickTucao = function(tucaoElementUI)
        {
            self.showTalk(GameGloble.Pos,tucaoElementUI.getString(),3);
            if(GameGloble.GameType == "1")
            {
                self.talkBn.setVisible(false);
            }
            else
            {
                self.talkBn.setVisible(true);
            }

            self.tucaoAction.play("HideTuCao",false);
            self.tucaoUI.isShowing = false;
            if(self.tucaoTimeOut == true)
            {
                g_GameNetWork.crossSendData("tucao",{tucaoIndex:tucaoElementUI.tucaoIndex});
                g_SoundManager.playTuCao(GameGloble.getPlayerSex(this.getPlayerHeadUrl(GameGloble.Pos)),tucaoElementUI.tucaoIndex);
                self.tucaoTimeOut = false;
                self.schedule(function()
                {
                    self.tucaoTimeOut = true;
                },0,0,4);
            }
            else
            {
                self.showImageTip("您说话太快了，请冷静！",1);
            }
        }

        var tucaoChilds = this.tucaoUI.getChildByName("BG").getChildren();
        for(var i = 0;i<tucaoChilds.length;i++)
        {
            var oneElement = tucaoChilds[i];
            oneElement.tucaoIndex = i;
            CocosHeler.setOnClickEvent(oneElement,clickTucao,this);
        }
        this.tucaoBn = this.sceneNode.getChildByName("TucaoBn");
        CocosHeler.setOnClickEvent(this.tucaoBn,function()
        {
            g_SoundManager.playHitMenuSound();
            g_SoundManager.playShowMenuSound();
            var show = !this.tucaoUI.isShowing;
            this.tucaoUI.isShowing = show;
            if(show)
            {
                this.tucaoAction.play("ShowTuCao",false);
                self.talkBn.setVisible(false);
                return;
            }
            this.tucaoAction.play("HideTuCao",false);
            if(GameGloble.GameType == "1")
            {
                self.talkBn.setVisible(false);
            }
            else
            {
                self.talkBn.setVisible(true);
            }

        },this);

        //----------------------------------取消托管-----------------------------------
        this.quxiaoTuoGuanBn = this.sceneNode.getChildByName("QuxiaoTuoGuanBn");
        CocosHeler.setOnClickEvent(this.quxiaoTuoGuanBn,function()
        {
            this.quxiaoTuoGuanBn.setVisible(false);
            //发送取消托管事件
            g_GameNetWork.crossSendData("tuoguan",{it:false});

        },this);

        //-----------------------------------最终底牌UI-------------------------------
        this.finishDipaiUI = this.sceneNode.getChildByName("FinishDipaiUI");
        this.finishDipaiUIDipaiPlane = this.finishDipaiUI .getChildByName("DipaiPlane");


        //------------------------------------升级界面----------------------------------
        this.powerUpUI = this.sceneNode.getChildByName("PowerUpUI");
        this.powerUpBG = this.powerUpUI.getChildByName("BG");
        this.powerUpUIChenghaoText = this.powerUpBG.getChildByName("ChenghaoText");
        this.powerUpUILunNumAdd = this.powerUpBG.getChildByName("LunNumAdd");
        this.powerUpUINextLongNum = this.powerUpBG.getChildByName("NextLongNum");
        this.powerUpUIAction = CocosHeler.connectAction(this.powerUpUI,res.PowerUpAction);

        //-----------------------------------离开排位界面------------------------------
        this.leaveRankUI = this.sceneNode.getChildByName("PlayerLeaveRankUI");
        this.leaveOrStaUI = this.sceneNode.getChildByName("RankLeaveOrStateUI");
        this.leaveOrSatRestar = this.leaveOrStaUI.getChildByName("Restart");
        this.quit = this.leaveOrStaUI.getChildByName("Quit");
        this.leaveOrStateXuanYap = this.leaveOrStaUI.getChildByName("XuanyaoBn");
        CocosHeler.setOnClickEvent(this.leaveOrStateXuanYap,function()
        {
            //微信分享
            Shares.baseShare();
        },this);
        CocosHeler.setOnClickEvent(this.leaveOrSatRestar,function()
        {
            this.hidePlayerLeaveOrStaUI();
        },this);
        CocosHeler.setOnClickEvent(this.quit,function()
        {
           //玩家离家房间
            g_GameNetWork.crossSendData('playerleavetable',{});
            if(GameGloble.GameType == 1)
            {
                cc.director.runScene(new ChooseGameUIScene());
            }
            else
            {
                cc.director.runScene(new HallUIScene());
            }
        },this);
        //---------------------------------龙骨不足UI-----------------------------
        this.longgubuzuUI = this.sceneNode.getChildByName("LonggubuzuUI");
        this.longgubuzuChongzhi = this.longgubuzuUI.getChildByName("Chongzhi");
        this.longgubuzuQuit = this.longgubuzuUI.getChildByName("Quit");
        CocosHeler.setOnClickEvent(this.longgubuzuChongzhi,function()
        {
            this.showChongZhiUI();
        },this);
        CocosHeler.setOnClickEvent(this.longgubuzuQuit,function()
        {
            cc.director.runScene(new ChooseGameUIScene());
        },this);

        //---------------------------------充值界面UI------------------------------
        this.shangchengBn = this.sceneNode.getChildByName("ShangChengBn");
        if(GameGloble.ShowShangdian == false)
        {
            this.shangchengBn.setVisible(false);
        }

        CocosHeler.setOnClickEvent(this.shangchengBn,function()
        {
            this.chongzhiUI.setVisible(true);
            g_SoundManager.playShangcheng();
        },this);

        this.waitingUI = this.sceneNode.getChildByName("WaitingUI");
        //------------------------和座位相关的控件--------------------------------
        //查找控件
        for(var key in this.uiMap)
        {
            var pos = key+"";
            var uiData = this.uiMap[key];
            //设置头像
            uiData.head = this.sceneNode.getChildByName(pos+"Head");
            CocosHeler.setOnClickEvent(uiData.head,function(headUI)
            {
                //发送请求玩家信息
                var account = headUI.account;
                var pos = headUI.pos;
                g_GameNetWork.crossSendData("askplayerinfo",{ac:account,pos:pos});
            },this);
            uiData.nameText = this.sceneNode.getChildByName(pos+"Name");
            uiData.hand = this.sceneNode.getChildByName(pos+"Hand");
            uiData.hitCardPlane = this.sceneNode.getChildByName(pos+"HitCardPlane");
            uiData.timeImage = this.sceneNode.getChildByName(pos+"Clock");
            uiData.timeNumText = uiData.timeImage.getChildByName("Num");
            uiData.zhaixingText = this.sceneNode.getChildByName(pos+"Zhaixing");
            uiData.xing1 = this.sceneNode.getChildByName(pos+"Xing1");
            uiData.xing2 = this.sceneNode.getChildByName(pos+"Xing2");
            uiData.xing3 = this.sceneNode.getChildByName(pos+"Xing3");

            uiData.zhuang = this.sceneNode.getChildByName(pos+"Zhuang");
            uiData.talkRoot = this.sceneNode.getChildByName(pos+"Talk");
            uiData.talkText = uiData.talkRoot.getChildByName("Text");
            uiData.talkBG = uiData.talkRoot.getChildByName("BG");

            var BG = this.showGetScoreUI.getChildByName("BG");
            uiData.showGetScoreName = BG.getChildByName(pos+"Name");
            uiData.showGetScoreScore = BG.getChildByName(pos+"Score");

            uiData.chengHao = this.sceneNode.getChildByName(pos+"Chenghao");
            uiData.chenghaoName = uiData.chengHao.getChildByName("BG").getChildByName("Name");
            uiData.chenghaoAction = CocosHeler.connectAction(uiData.chengHao,res.ChenghaoAction);
            uiData.chenghaoAction.play("Run",true);

            uiData.tuoguan = this.sceneNode.getChildByName(pos+"TuoGuan");

            uiData.offline = this.sceneNode.getChildByName(pos+"Offline");
        }

        this.setHeadAndName("bottom",GameGloble.ChenghaoHeadUrl,GameGloble.UserName);
        //cc.log("我进入了，我的头像地址是 "+GameGloble.ChenghaoHeadUrl);
        var bottomHead = this.uiMap["bottom"].head;
        bottomHead.account = GameGloble.UserAccount;
        bottomHead.pos = GameGloble.Pos;
        this.showChenghao(GameGloble.Pos,GameGloble.Chenghao);

        //--------------------------------屏幕输入框--------------------------------------

        //屏幕上的输入按钮
        var talkBn = this.talkBn = this.sceneNode.getChildByName("ShuoHuaBn");
        CocosHeler.setOnClickEvent(talkBn,function()
        {
            self.talkEditBox.showEdit();
        },this);
        if(GameGloble.GameType == 1)//比赛场说话功能不可见
        {
            talkBn.setVisible(false);
        }

        var self = this;
        this.canTalkMarsk = true;
        var talkOkEvent = function()
        {
            //发送说的话
            if(self.canTalkMarsk == false)
            {
                self.showImageTip("您说的话太快了，冷静...",2);
                self.talkEditBox.hideEdit();
                return;
            }
            self.canTalkMarsk = false;
            var talkString = self.talkEditBox.editBoxUI.string;
            cc.log("说的话"+talkString);
            self.talkEditBox.hideEdit();
            self.schedule(function()
            {
                self.canTalkMarsk = true;
            },0,0,3);
            //发送服务器

            //截取20个字符
            talkString = talkString.slice(0,15);
            g_GameNetWork.crossSendData('playertalk',{talk:talkString});
        };
        this.talkEditBox = GuiController.createGameEditBox(talkOkEvent);
        this.addChild(this.talkEditBox);
        this.talkEditBox.hideEdit();

        //初始化玩家信息界面
        this.baseInfoUI = GuiController.initBasePlayerInfoUI(this.sceneNode);

        //初始化普通信息提示
        this.normalMessage = GuiController.initNormalMessageUI(this.sceneNode);
        //初始化退出游戏界面
        GuiController.initQuitGameUI(this.sceneNode);

        //var self = this;
        //this.quitMessage = this.sceneNode.getChildByName("MessageBox").getChildByName("MessageBox");
        //this.quitMessageeBoxAction = CocosHeler.connectAction(this.quitMessage,res.LoginUI);
        //this.quitMessage.getChildByName("InfoText").setString("确定结束游戏?");
        //GuiController.initMessageBoxEvent(this.quitMessage,function()
        //{
        //    cc.director.end();
        //},function()
        //{
        //    self.quitMessageeBoxAction.play("HideMessageBox",false);
        //});

        //------------------------------------游戏更新--------------------------------
        this.schedule(function()
        {
            if(this.playingState != 0)
            {
                this.prepareBn.setVisible(false);
                this.prepareBnTipInfo.setVisible(false);
                this.hideHeadAndName("bottom");
            }
        },0.5,Number.MAX_VALUE,0);

        if(GameGloble.reConnectData == null)
        {
            g_GameNetWork.crossSendData('gametableprepareinfo',{});//请求桌子的准备情况
            if(GameGloble.GameType ==1)
            {
                this.prepareBn.setVisible(false);
                g_GameNetWork.crossSendData('preparestate',{ip:true});//因为是龙固赛，进入游戏后，需要直接准备
            }
        }
        else
        {
            if(GameGloble.GameType == 0)
            {
                this.playerReconnectNormalGame(GameGloble.reConnectData);
            }
            else
            {
                this.playerReconnectRankGame(GameGloble.reConnectData);
            }
            GameGloble.reConnectData = null;
        }
        var socketClient = GameGloble.g_webSocketClient;
        //监听网络连接事件
        socketClient.onConnectEvent.addEventListener("GameUI",function()
        {
            GameGloble.reloginServer();
        });
        socketClient.onReloginEvent.addEventListener("GameUI",function()
        {
            if(GameGloble.GameType == 1)
            {
               if(GameGloble.IsPlaying == true)return;//接收到重新连接的事件后，会重新加载界面
                cc.director.runScene(new ChooseGameUIScene());
            }
            else
            {
                if(GameGloble.IsPlaying == false)
                {
                    cc.director.runScene(new HallUIScene());
                }
                else
                {
                    return;
                }
            }
        });
        socketClient.onCloseEvent.addEventListener("GameUI",function()
        {
            GuiController.showWaitingUI(self.waitingUI,"网络不稳定，正在重新连接服务器...",Number.MAX_VALUE);

        });

        if(GameGloble.HallID == 1 || GameGloble.GameType ==1)
        {
            this.tucaoBn.setVisible(false);
            this.talkBn.setVisible(false);
        }
        //-----------------------------显示广告--------------------------------
        Ads.showGDTChaping();
        //--------------------------------------单元测试函数------------------------------------------
        //return;
        //var shangshoupaiData = {};
        //shangshoupaiData['top'] = [53,54];
        //shangshoupaiData['left'] = [1];
        //shangshoupaiData['bottom'] = [13,27];
        //shangshoupaiData['right'] = [2,94,107];
        //this.showShangshoupaiUI(shangshoupaiData);
        //return;
       // GameHelper.changeBlackAndRed(this.mainType);
        cc.log("加载完成");
        return;
        this.mainType = 1;
        this.playingState = 2;
        var i = 0;
        var cardIndex = 53;
        this.keyNum = 1;
        this.schedule(function()
        {
            this.addOneHandCardIndex(cardIndex);
            console.log(GameHelper.getPower(GameHelper.getCard(cardIndex),this.mainType,this.keyNum));
            i+=1;
            cardIndex+=1;
            this.repositionCardsNormal();
            if(i == 30)
            {
                //cardIndex+=1;
                //this.expandCardUIS(4);
            }
        },0.01,2);

        //this.showFinishDipaiUI([17,18,19,21,23,53]);
        //this.showHitCards("bottom",[5,10,13]);
        //this.showHitCards("left",[18,23,26]);
        //this.showHitCards("right",[5,10,13]);
        //this.showHitCards("top",[59,64,67]);
        //
        //this.totalEatScoreNum = 115;
        //this.eatScore(15);
        //
        //this.showGetScoreFinishUI({top:{name:"李腾飞1",score:"50"},left:{name:"李腾飞1",score:"6"},
        //    bottom:{name:"李腾飞1",score:"-1"}
        //,right:{name:"李腾飞1",score:"30"}});

        //this.showFinishDipaiUI([1,2,3,4,5,6]);
        //this.eatScore(20);
        //this.showPowerUPUI(1,"西海龙王",100);
        //this.showRemainJuNum(1);



        //this.setUpSelectCardEvent();

        //-----------------------显示超时UI--------------------------
        //this.showTimeOutUI("bottom",20,function()
        //{
        //    console.log("Time Out!");
        //});


        //-----------------------出牌UI测试--------------------------

    },
    onExit:function()
    {
        this._super();
        GameGloble.IsPlaying = false;
        g_SoundManager.playNormalBackGround();
        //隐藏Banner
        Ads.hideGDTBanner();
        GameGloble.g_webSocketClient.onReloginEvent.removeListener("GameUI");
        GameGloble.g_webSocketClient.onCloseEvent.removeListener("GameUI");
        GameGloble.g_webSocketClient.onConnectEvent.removeListener("GameUI");
    },
    //添加选择牌的事件
    setUpSelectCardEvent:function()
    {
        var selecting = false;
        this.lastSelectType = null;//上一次选择的类型
        this.currentSelectCardUI = null;
        var self = this;

        var findTopCardUI =  function (touch)
        {
            var maxZOrder = 0;
            var topSelectCard = null;
            var cardUIs = self.handCardPlane.getChildren();
            for(var key in cardUIs)
            {
                var cardUI = cardUIs[key];
                if(CocosHeler.touchInSprite(touch,cardUI) == false)continue;
                if(cardUI.getLocalZOrder()<maxZOrder)continue;
                maxZOrder = cardUI.getLocalZOrder();
                topSelectCard = cardUI;
            }
            return topSelectCard;
        }


        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE, //TOUCH_ONE_BY_ONE 为单次触摸事件监听器
            swallowTouches: true,
            onTouchBegan: function (touch, event)
            {
                if(self.playingState<=1)return false;
                var selectUI = findTopCardUI(touch);
                if(selectUI == null) return true;
                var handCardCounts = self.handCardPlane.getChildrenCount();

                selecting = true;
                self.currentSelectCardUI = selectUI;
                self.autoSelectOrUnselectCard(selectUI);
                //第一次点击或者是切换了不同的类型
                var currentSelectType = GameHelper.getCardType(selectUI.index,self.keyNum,self.mainType);
                if(handCardCounts<=25)
                {
                    self.repositionSelectCards(selectUI);//展开选择的牌的类型
                    self.lastSelectType = currentSelectType;
                    return true;
                }
                if(currentSelectType == self.lastSelectType)
                {
                    return true;
                }
                else
                {
                    self.repositionSelectCards(selectUI);//展开选择的牌的类型
                    self.lastSelectType = currentSelectType;
                    return false;
                }
            },
            onTouchEnded: function (touch, event)
            {
                selecting = false;
                self.currentSelectCardUI = null;
                return false;
            },
            onTouchMoved:function(touch, event)
            {
                if(selecting == false)return false;
                var selectUI = findTopCardUI(touch);
                if(selectUI == null || selectUI == self.currentSelectCardUI)return true;
                self.currentSelectCardUI = selectUI;
                var currentSelectType = GameHelper.getCardType(selectUI.index,self.keyNum,self.mainType);
                self.autoSelectOrUnselectCard(selectUI);
                if(currentSelectType != self.lastSelectType)
                {
                    self.repositionSelectCards(selectUI);
                    self.lastSelectType = currentSelectType;
                }
                return false;
            }
        });
        cc.eventManager.addListener(listener, this.handCardPlane);
    },
    isSameCardType:function(one,one1)
    {
        var type1 = GameHelper.getCardType(one.index,this.keyNum,this.mainType);
        var type2 = GameHelper.getCardType(one1.index,this.keyNum,this.mainType);
        if(type1 == type2)
        {
            return true;
        }
        return false;
    },
    autoSelectOrUnselectCard:function(cardUISprite)
    {
        var selected = !cardUISprite.Selected;
        cardUISprite.Selected = selected;
        cardUISprite.CardOverUI.setVisible(selected);
        if(selected == true)
        {
            cardUISprite.runAction(CardUIManager.createSelectCardUIAction());
            this.selectCardUIs.push(cardUISprite);
        }
        else
        {
            cardUISprite.runAction(CardUIManager.createUnSelectCardUIAction());
            JSUseFullFramework.removeArray(this.selectCardUIs,cardUISprite);
        }
        //this.repositionSelectCards(cardUISprite);
    },
    unselectHandCard:function()
    {
        var childs = this.handCardPlane.getChildren();
        for(var key in childs)
        {
            var oneCardUI = childs[key];
            if(oneCardUI.Selected == true) {
                this.autoSelectOrUnselectCard(oneCardUI);
            }
        }
        this.selectCardUIs = [];
    },
    getSameAndUnSameCardUI:function(cardUI)
    {
        var sameTypeCardUIs = [];
        var unSameTypeCardUIs  = [];
        var type = GameHelper.getCardType(cardUI.index,this.keyNum,this.mainType);
        var childs = this.handCardPlane.getChildren();
        for(var key in childs)
        {
            var oneChild = childs[key];
            if(type == GameHelper.getCardType(oneChild.index,this.keyNum,this.mainType))
            {
                sameTypeCardUIs.push(oneChild);
            }
            else
            {
                unSameTypeCardUIs.push(oneChild);
            }
        }
        return {same:sameTypeCardUIs,unsame:unSameTypeCardUIs};
    },
    repostionCardsMarginXAndCenter:function()
    {
        var array = this.handCardPlane.getChildren().sort(function(a,b)
        {
            var delta =  b.power- a.power;
            return delta
        });
        for(var key in array)
        {
            var oneCardUI = array[key];
        }

        CocosHeler.UpdateMarginX(array,this.handCardPlane);
        CocosHeler.centerMarginChildsNotCrossLeft(array,this.handCardPlane);
    },
    repositionCardsNormal:function()
    {
        var counts = this.handCardPlane.getChildrenCount();
        var childs = this.handCardPlane.getChildren();
        var minBetween = 28;
        var maxMaxBeteen = 80;


        //计算出应该的Between值，线性的
        var currentBetween = 1280/counts;

        currentBetween = currentBetween>maxMaxBeteen?maxMaxBeteen:currentBetween;
        currentBetween = currentBetween<minBetween?minBetween:currentBetween;
        for(var key in childs)
        {
            var oneChild = childs[key];
            oneChild.MarginRight = currentBetween;
        }
        this.repostionCardsMarginXAndCenter();
        //this.lastSelectType = null;//因为重新重置了排列，所以就不存在上一次的选择了，需要重置
    },
    repositionSelectCards:function(cardUI)
    {

        var totalLength = 1280;
        var selectMinBetween = 45;
        var selectMaxBetween = 60;

        var unSelectMinBetween = 18;
        var unSelectMaxBetween = 60;


        var cardUIS = this.handCardPlane.getChildren();
        var cardUICounts = cardUIS.length;
        if(cardUICounts <=20)return;
        if(cardUICounts == 45)//扣底的时候牌太多了,导致了挤压，因此，设置为55间距
        {
            selectMinBetween = 45;
            selectMaxBetween = 55;
        }

        var sameAndUnSameCardUIs = this.getSameAndUnSameCardUI(cardUI);

        var sameTypeUIs = sameAndUnSameCardUIs.same;
        var unSameTypesUIs = sameAndUnSameCardUIs.unsame;

        var selectCount = sameTypeUIs.length+1;


        var realSelectBetween = selectMaxBetween;

        var unSelectLength = totalLength - realSelectBetween*(selectCount);
        var unSelectCount = cardUICounts - selectCount;


        var realUnSelectBetween = unSelectLength/(unSelectCount);
        if(unSelectCount == 0)realUnSelectBetween = 0;

        if(realUnSelectBetween<unSelectMinBetween)//没有选中的牌太挤了，需要按没有选中的牌的最小距离铺垫
        {
            unSelectLength = unSelectMinBetween*(unSelectCount);
            realUnSelectBetween = unSelectMinBetween;
            realSelectBetween = (totalLength - unSelectLength)/(selectCount);
        }

        if(realUnSelectBetween > realSelectBetween)realUnSelectBetween = realSelectBetween;

        realSelectBetween = realSelectBetween > selectMaxBetween?selectMaxBetween:realSelectBetween;

        for( var key in sameTypeUIs)
        {
            var oneSameTypeCard = sameTypeUIs[key];
            oneSameTypeCard.MarginRight = realSelectBetween;
        }

        for(var key in unSameTypesUIs)
        {
            var oneUnSameType = unSameTypesUIs[key];
            oneUnSameType.MarginRight = realUnSelectBetween;
        }
        this.repostionCardsMarginXAndCenter();
    },
    expandCardUIS:function(cardType)
    {
        if(this.lastSelectType == cardType)return;
        var childs = this.handCardPlane.getChildren();
        for(var key in childs)
        {
            var oneChild = childs[key];
            var oneType = GameHelper.getCardType(oneChild.index,this.keyNum,this.mainType);
            if(oneType == cardType)
            {
                this.repositionSelectCards(oneChild);
                this.lastSelectType = oneType;
                return;
            }
        }
    },
    addOneHandCardIndex:function(cardIndex)
    {
       var card = GameHelper.getCard(cardIndex);
        var power = GameHelper.getPower(card,this.mainType,this.keyNum);
        var newCard = CardUIManager.createHandCard(card.cardNum,card.cardType);
        newCard.power = power;
        newCard.index = cardIndex;
        this.handCardPlane.addChild(newCard);
    },
    removeOneHandCardIndex:function(cardIndex)
    {
        var childs = this.handCardPlane.getChildren();
        for(var key in childs)
        {
            var oneCardUI = childs[key];
            if(oneCardUI.index == cardIndex)
            {
                this.handCardPlane.removeChild(oneCardUI,true);
                return;
            }
        }
    },
    removeHandCardIndexsAndReposition: function (cardIndexs)
    {
        var childs = this.handCardPlane.getChildren();
        var removeUIS = [];
        for(var key in childs)
        {
            var oneCardUI = childs[key];
            for(var key1 in cardIndexs)
            {
                var removeIndex = cardIndexs[key1];
                if(oneCardUI.index == removeIndex)
                {
                    removeUIS.push(oneCardUI);
                }
            }
        }
        for(var key in removeUIS)
        {
            var removeOneUI = removeUIS[key];
            this.handCardPlane.removeChild(removeOneUI);
        }
        this.repositionCardsNormal();
    },
    makeMain:function(pos,mainCardIndex)
    {
        var mainCard = GameHelper.getCard(mainCardIndex);
        this.mainType = mainCard.cardType;
        this.dadiPos = pos;
        var screenPos = this.getScreenPos(pos);
        this.showZhuang(pos);

        GameHelper.changeBlackAndRed(this.mainType);

        //重新计算权重
        var childs = this.handCardPlane.getChildren();
        for(var key in childs)
        {
            var oneCardUI = childs[key];
            var oneCard = GameHelper.getCard(oneCardUI.index);
            oneCardUI.power = GameHelper.getPower(oneCard,this.mainType,this.keyNum);
        }
        this.repositionCardsNormal();
    },
    getScreenPos:function(pos)
    {
        var playerRealPos = GameGloble.Pos;
        var playerIndex = this.posIndex[playerRealPos];

        var temp = 2 - playerIndex;
        temp  = temp ==-1?3:temp;

        var index = this.posIndex[pos];
        var screenIndex = parseInt((index+temp)%4);
        return this.numPosIndex[screenIndex];
    },
    getPlayerHeadUrl:function(pos)
    {
        var screenPos = this.getScreenPos(pos);
        var uiData = this.uiMap[screenPos];
        return uiData.headKey;
    },
    showTimeOutUI:function(pos,time,callback)
    {
       var screenPos = this.getScreenPos(pos);
        var timeText = null;
        var tickTime = time;
        var currentShowTime = null;
        for(var key in this.uiMap)
        {
            var oneUI = this.uiMap[key];
            var timeImage = oneUI.timeImage;
            if(key == screenPos)
            {
                currentShowTime = timeImage;
                timeImage.setVisible(true);
                timeText = oneUI.timeNumText;
                timeText.setString(time);
            }
            else
            {
                timeImage.setVisible(false);
            }
        }
        this.showTimeTick = function()
        {
            tickTime-=1;
            timeText.setString(tickTime);
            if(tickTime == 0)
            {
                currentShowTime.setVisible(false);
                if( typeof callback != "undefined")callback();
            }
        };
        this.schedule(this.showTimeTick,1,time-1);
    },
    hideTimeOut:function()
    {
       for(var key in this.uiMap)
       {
           var oneUI = this.uiMap[key];
           oneUI.timeImage.setVisible(false);
       }
        this.unschedule(this.showTimeTick);
    },
    setHeadAndName:function(pos,headUrl,name)
    {
        var uiData = this.uiMap[pos];
        uiData.head.loadTexture(headUrl);
        uiData.headKey = headUrl;
        uiData.head.setVisible(true);
        uiData.nameText.setString(name);
        uiData.nameText.setVisible(true);
    },
    hideHeadAndName:function(pos)
    {
        var uiData = this.uiMap[pos];
        uiData.head.setVisible(false);
        uiData.nameText.setVisible(false);
    },
    setPrePare:function(pos,isPrepare)
    {
        var uiData = this.uiMap[pos];
        uiData.hand.setVisible(isPrepare)
    },
    hidePrePare:function(pos)
    {
        var uiData = this.uiMap[pos];
        uiData.hand.setVisible(false);
    },
    clearPrePare:function()
    {
        for(var key in this.uiMap)
        {
            this.uiMap[key].hand.setVisible(false);
        }
        this.prepareBn.setVisible(false);
        this.prepareBnTipInfo.setVisible(false);
    },
    showBifenUI:function()
    {
        this.bifenLeft.setVisible(true);
        this.bifenImage.setVisible(true);
        this.bifenRight.setVisible(true);
    },
    showBifenText:function(left,right)
    {
        this.bifenLeft.setVisible(true);
        this.bifenLeft.setString(left);
        this.bifenImage.setVisible(true);
        this.bifenRight.setVisible(true);
        this.bifenRight.setString(right);

    },
    hideBifenText:function()
    {
        this.bifenLeft.setVisible(false);
        this.bifenImage.setVisible(false);
        this.bifenRight.setVisible(false);
    },

    showEatScoreNum:function(num)
    {
        this.chiFenNum.setVisible(true);
        this.chiFenNum.setString(num);
    },
    HideEatScoreNum:function()
    {
        this.chiFenNum.setVisible(false);
    },
    showFanzhuUI:function()
    {
        this.fanzhu.setVisible(true);
        this.bufanzhu.setVisible(true);
        this.fanzhu.setLocalZOrder(this.topZIndex);
        this.bufanzhu.setLocalZOrder(this.topZIndex);
    },
    hideFanzhuUI:function()
    {
        this.fanzhu.setVisible(false);
        this.bufanzhu.setVisible(false);
    },
    showKoudiUI:function()
    {
        this.koudi.setVisible(true);
    },
    hideKoudiUI:function()
    {
        this.koudi.setVisible(false);

    },
    showZhufuPlane:function()
    {
        if(this.mainType == -1)return;//还没有定主
        this.bottomZhuD.setVisible(true);
        this.bottomZhuType.setVisible(true);
        this.bottomZhuNum.setVisible(true);

        var childs = this.handCardPlane.getChildren();
        var mainTypeNum = 0;
        for(var key in childs)
        {
            var oneCardUI = childs[key];
            var cardType = GameHelper.getCardType(oneCardUI.index,this.keyNum,this.mainType);
            if(cardType == 5)mainTypeNum+=1;
        }
        this.bottomZhuNum.setString(mainTypeNum);
        this.bottomZhuType.setSpriteFrame(CardUIManager.getZhuTypeFrame(this.mainType));
    },
    hideZhufuPlane:function()
    {
        this.bottomZhuD.setVisible(false);
        this.bottomZhuType.setVisible(false);
        this.bottomZhuNum.setVisible(false);
    },
    showYaoxingUI:function()
    {
        this.yaoxing.setVisible(true);
        this.buyaoxing.setVisible(true);
    },
    hideYaoxingUI:function()
    {
        this.yaoxing.setVisible(false);
        this.buyaoxing.setVisible(false);
    },
    showZhaixingUI:function()
    {
        //根据王子的数量显示摘星界面
        var kingNum = this.getKingNum();
        if(kingNum ==0)return;
        this.buzhaixing.visible = true;
        if(kingNum == 1)
        {
            this.zhaixing1.visible = true;
        }
        else if(kingNum ==2)
        {
            this.zhaixing1.visible = true;
            this.zhaixing2.visible = true;
        }
        else if(kingNum ==3)
        {
            this.zhaixing1.visible = true;
            this.zhaixing2.visible = true;
            this.zhaixing3.visible = true;
        }
    },
    hideZhaixingUI:function()
    {
        this.buzhaixing.setVisible(false);
        this.zhaixing1.setVisible(false);
        this.zhaixing2.setVisible(false);
        this.zhaixing3.setVisible(false);
    },
    showHitCardUI:function()
    {
        this.hitCardBn.setVisible(true);
        this.tipCardBn.setVisible(true);
    },
    hideHitCardUI:function()
    {
        this.hitCardBn.setVisible(false);
        this.tipCardBn.setVisible(false);
    },
    getKingNum:function()
    {
        var kingNum = 0;
        var childs = this.handCardPlane.getChildren();
        for(var key in childs)
        {
            var oneCardUI = childs[key];
            var card = GameHelper.getCard(oneCardUI.index);
            if(card.cardType == 5 && card.cardNum ==1)
            {
                kingNum+=1;
            }
        }
        return kingNum;
    },
    getCardUIWithIndex:function(index)
    {
        var childs = this.handCardPlane.getChildren();
        for(var key in childs)
        {
            var oneCardUI = childs[key];
            if(oneCardUI.index == index)
            {
                return oneCardUI;
            }
        }
        return null;
    },
    showZhaixingPlane:function(pos,kingNum)
    {
        if(kingNum == 0)return;
        var screenPos = this.getScreenPos(pos);
        var uidata = this.uiMap[screenPos];
        uidata.zhaixingText.setVisible(true);
        var xingArray = [uidata.xing1,uidata.xing2,uidata.xing3];
        for(var i = 0;i<kingNum;i++)
        {
            xingArray[i].setVisible(true);
        }
    },
    hideZhaixingPlane:function()
    {
        for(var key in this.uiMap)
        {
            var oneUI = this.uiMap[key];
            oneUI.zhaixingText.setVisible(false);
            oneUI.xing1.setVisible(false);
            oneUI.xing2.setVisible(false);
            oneUI.xing3.setVisible(false);
        }
    },
    showTextTip:function(text)
    {
        this.tipText.setVisible(true);
        this.tipText.setString(text);
    },
    hideTextTip:function()
    {
        this.tipText.setVisible(false);
    },
    showImageTip:function(text,time)
    {
        var self = this;
        var action = cc.fadeIn(1);
        this.tipImage.setVisible(true);
        this.tipImageText.setVisible(true);
        this.tipImageText.setString(text);

        this.tipImage.setOpacity(0.5);
        this.tipImageText.setOpacity(0.5);

        var fadeInAction = cc.fadeIn(time);
        var fadeOutAction = cc.fadeOut(time);

        var finalAction = cc.sequence(fadeInAction,fadeOutAction);

        self.tipImage.runAction(finalAction);
        self.tipImageText.runAction(finalAction.clone());
    },
    hideImageTip:function()
    {
        this.tipImage.setVisible(false);
    },
    showZhuang:function(pos)
    {
        var screenPos = this.getScreenPos(pos);
        for(var key in this.uiMap)
        {
            var oneUI = this.uiMap[key];
            if(screenPos == key)oneUI.zhuang.setVisible(true);
            else oneUI.zhuang.setVisible(false);
        }
    },
    hideZhuang:function()
    {
        for(var key in this.uiMap)
        {
            var oneUI = this.uiMap[key];
            oneUI.zhuang.setVisible(false);
        }
    },
    showHitCards:function(pos,cardIndexArray)
    {
        var screenPos = this.getScreenPos(pos);
        var hitCardPlane = this.uiMap[screenPos].hitCardPlane;
        hitCardPlane.removeAllChildren(true);
        hitCardPlane.setVisible(true);
        for(var key in cardIndexArray)
        {
            var oneCardIndex = cardIndexArray[key];
            var oneCard = GameHelper.getCard(oneCardIndex);
            var oneHitCardUI = CardUIManager.createHitCard(oneCard.cardNum,oneCard.cardType);
            oneHitCardUI.index = oneCardIndex;
            oneHitCardUI.MarginRight = oneHitCardUI.getContentSize().width-13;
            hitCardPlane.addChild(oneHitCardUI);
        }
        CocosHeler.UpdateMarginX(hitCardPlane.getChildren(),hitCardPlane);
        CocosHeler.centerMarginChilds(hitCardPlane.getChildren(),hitCardPlane);
    },
    clearHitCardPlane:function()
    {
        for(var key in this.uiMap)
        {
            var oneUI = this.uiMap[key];
            oneUI.hitCardPlane.removeAllChildren(true);
        }
    },
    clearHandCards:function()
    {
        this.handCardPlane.removeAllChildren(true);
    },
    //重置手里的牌
    checkAndResetHandCards:function(serverHandCards)
    {
        var handLength = this.handCardPlane.getChildrenCount();
        var serverHandLength = serverHandCards.length;
        //牌的数量不同，直接重置
        var checkNeedReset = function()
        {
            if(handLength != serverHandLength)
            {
                return true;
            }
            return false;
            //else //判断每一张牌的是否相等
            //{
            //    for(var key in handCardsUIs)
            //    {
            //        var handIndex = handCardsUIs[key].index;
            //        for(var key1 in serverHandCards)
            //        {
            //            var serverIndex = serverHandCards[key1];
            //            if(handIndex != serverIndex)
            //            {
            //                return true;
            //            }
            //        }
            //    }
            //}
        }

        var needReset = checkNeedReset();
        if(needReset == false)
        {
            cc.log("牌的数量相等，不需要重制");
            return;
        }
        //var needReset = true;
        cc.log("需要重制"+needReset);
        this.unselectHandCard();
        this.clearHandCards();
        this.lastSelectType = null;

        for(var key in serverHandCards)
        {
            var oneIndex = serverHandCards[key];
            this.addOneHandCardIndex(oneIndex);
        }
        this.repositionCardsNormal();
        cc.log("重制完成!");
    },
    checkCanHitCard:function()
    {
        var selectCards = [];
        var childs = this.handCardPlane.getChildren();

        for(var key in this.selectCardUIs)
        {
            var oneChild = this.selectCardUIs[key];
            selectCards.push(oneChild.index);
        }



        if(this.isFirstHitCard == true)
        {
            if(selectCards.length == 0)return false;

            var firstIndex = selectCards[0];
            var firstCard = GameHelper.getCard(firstIndex);
            for(var i = 1;i<selectCards.length;i++)
            {
                var theCardIndex = selectCards[i];
                var theCard = GameHelper.getCard(theCardIndex);
                if(!(firstCard.cardNum == theCard.cardNum && firstCard.cardType == theCard.cardType)){return false;};
            }
            return true;
        }



        else
        {
            if(selectCards.length != this.firstHitCards.length)return false;

            var tempCardIndex = this.firstHitCards[0];
            var tempCard = GameHelper.getCard(tempCardIndex);

            var tempType = GameHelper.getCardType(tempCardIndex,this.keyNum,this.mainType);

            var typeCardIndex = [];

            var childs = this.handCardPlane.getChildren();
            for(var key in childs)
            {
                var oneCard = childs[key];
                var oneType = GameHelper.getCardType(oneCard.index,this.keyNum,this.mainType);
                if(oneType == tempType)typeCardIndex.push(oneCard.index);
            }

            var firstHitCardLength = this.firstHitCards.length;

            var needTypeNums = 0;//出的牌中需要的类型数目，如果达不到，则不满足出牌规则

            //同类型的牌满足
            if(typeCardIndex.length >=firstHitCardLength)
            {
                needTypeNums = firstHitCardLength;
            }
            else//有多少给出多少
            {
                needTypeNums = typeCardIndex.length;
            }


            //得到选择的牌中该类型的数量
            var selectTypeNum = 0;

            for(var key in selectCards)
            {
                var oneSelectCard = selectCards[key];
                var oneSelectType = GameHelper.getCardType(oneSelectCard,this.keyNum,this.mainType);
                if(oneSelectType == tempType)selectTypeNum+=1;
            }

            if(selectTypeNum == needTypeNums)return true;
        }
        return false;
    },
    turnToHitCard:function(pos)
    {
        var self = this;
        if(GameGloble.isMyPos(pos))
        {
            this.showHitCardUI();
        }
        this.showTimeOutUI(pos,20,function()
        {
            this.hideTimeOut();
        });
    },
    showTopZhuIcon:function()
    {
        return;
        this.topZhuType.setVisible(true);
        this.topZhuType.setSpriteFrame(CardUIManager.getZhuTypeFrame(this.mainType));
        this.topZhuText.setVisible(true);
    },
    hideTopZhuIcon:function()
    {
        this.topZhuType.setVisible(false);
        this.topZhuType.setSpriteFrame(CardUIManager.getZhuTypeFrame(this.mainType));
        this.topZhuText.setVisible(false);
    },
    showBigIcon:function()
    {
        var hitCardCardIndexArray = {};
        var firstHitCardScreenPos = this.getScreenPos(this.firstHitCardPos);
        for(var key in this.uiMap)
        {
            var oneUIData = this.uiMap[key];
            var hitCardPlane = oneUIData.hitCardPlane;
            var cardCount = hitCardPlane.getChildrenCount();
            if(cardCount == 0)continue;
            var childs = hitCardPlane.getChildren();
            childs[cardCount-1].bigIcon.setVisible(false);
            var indexsArray = [];
            for(var key1 in childs)
            {
                var oneCardUI = childs[key1];
                indexsArray.push(oneCardUI.index);
            }
            hitCardCardIndexArray[key] = indexsArray;
        }
        var bigPos = GameHelper.checkWhoBig(firstHitCardScreenPos,hitCardCardIndexArray,this.keyNum,this.mainType);

        var hitCardPlane = this.uiMap[bigPos].hitCardPlane;
        var counts = hitCardPlane.getChildrenCount();
        var childs = hitCardPlane.getChildren();
        childs[counts-1].bigIcon.setVisible(true);
    },
    showShaIcon:function(hitCardPos)
    {
        var firtHitCardType = GameHelper.getCardType(this.firstHitCards[0],this.keyNum,this.mainType);
        if(firtHitCardType == 5)return false;
        var hitCardsIndex = [];
        var screenPos = this.getScreenPos(hitCardPos);
        var hitCardUIs = this.uiMap[screenPos].hitCardPlane.getChildren();
        for(var key in hitCardUIs)
        {
            hitCardsIndex.push(hitCardUIs[key].index);
        }
        if(GameHelper.isSameCard(hitCardsIndex) == false)return false;

        var hitCardType = GameHelper.getCardType(hitCardsIndex[0],this.keyNum,this.mainType);
        if(hitCardType != 5)return false;

        hitCardUIs[hitCardUIs.length-1].shaIcon.setVisible(true);
        g_SoundManager.playShaSound(GameGloble.getPlayerSex(this.getPlayerHeadUrl(hitCardPos)));
        return true;
    },
    getHitCardsScoreIndexs:function()
    {
        var eatScoreCardArray = [];
        for(var key in this.uiMap)
        {
            var oneUIData = this.uiMap[key];
            var cardUIS = oneUIData.hitCardPlane.getChildren();
            for(var key in cardUIS)
            {
                var oneCardUI = cardUIS[key];
                var index = oneCardUI.index;
                var card = GameHelper.getCard(index);
                var cardNum = card.cardNum;
                if(cardNum == 5 || cardNum == 10 || cardNum ==13)
                {
                    eatScoreCardArray.push(index)
                }
            }
        }
        return eatScoreCardArray;
    },
    getDiCardsScoreIndexs:function()
    {
        var eatScoreCardArray = [];
        for(var key in this.dicards)
        {
            var oneCardIndex = this.dicards[key];
            var oneCard = GameHelper.getCard(oneCardIndex);
            var cardNum = oneCard.cardNum;
            if(cardNum == 5 || cardNum == 10 || cardNum ==13)
            {
                eatScoreCardArray.push(oneCardIndex)
            }
        }
        return eatScoreCardArray;
    },
    eatScore:function(score,scoreCardIndexs)
    {
        if(this.totalEatScoreNum>120)return;//分够了，就不再显示吃分的画面了

        var eatScoreCardArray = [];
        for(var key in scoreCardIndexs)
        {
            var oneIndex = scoreCardIndexs[key];
            var oneCard = GameHelper.getCard(oneIndex);
            eatScoreCardArray.push(oneCard);
        }
        //显示动画
        var showNum2 = score>=10?true:false;
        this.eatScoreAnimationUI.setVisible(true);
        this.eatScoreNum2.setVisible(showNum2);
        var scoreString = ""+score;
        var num1 = scoreString[0];
        var num2 = typeof scoreString[1]=="undefined"?0:scoreString[1];

        num1 = num1+"-1Num.png";
        num2 = num2+"-1Num.png";
        this.eatScoreNum1.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(num1));
        this.eatScoreNum2.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(num2));
        this.eatScoreAction.play("Show",false);

        //吃分的总数增加
        this.totalEatScoreNum+=score;
        this.chiFenNum.setVisible(true);
        this.chiFenNum.setString(this.totalEatScoreNum);

        //吃分面板的牌增加
        var addCardUI = this.chiFenPlaneTop;

        for(var key in eatScoreCardArray)
        {
            if(addCardUI.getChildrenCount()>=10)
            {
                addCardUI = this.chifenPlaneBottom;
            }
            var oneCard = eatScoreCardArray[key];
            var cardUI = CardUIManager.createEatScorePlaneCard(oneCard.cardNum,oneCard.cardType);
            cardUI.MarginRight = cardUI.getContentSize().width;
            addCardUI.addChild(cardUI);
        }
        CocosHeler.UpdateMarginX(this.chiFenPlaneTop.getChildren(),this.chiFenPlaneTop);
        CocosHeler.UpdateMarginX(this.chifenPlaneBottom.getChildren(),this.chifenPlaneBottom);

        if(this.totalEatScoreNum>=120)
        {
            //播放分数够了的动画
            this.fenshuDabiao.setVisible(true);
            var fadinAction = cc.fadeIn(1.5);
            var fadeOutAction = cc.fadeOut(1);
            var finalAction = cc.sequence(fadinAction,fadeOutAction);
            this.fenshuDabiao.runAction(finalAction);
        }
    },
    clearEatScoreUI:function()
    {
        this.chiFenNum.setVisible(false);
        this.chiFenPlaneTop.removeAllChildren(true);
        this.chifenPlaneBottom.removeAllChildren(true);
    },
    showKandiBn:function()
    {
        this.kandi.setVisible(true);
    },
    hideKandiBn:function()
    {
      this.kandi.setVisible(false);
    },
    showKandiUI:function()
    {
        this.kandiUI.setVisible(true);
    },
    hideKandiUI:function()
    {
        this.kandiUI.setVisible(false);
    },
    clearKandiUICards:function()
    {
        this.kandUiDiCardsPlane.removeAllChildren(true);
        this.kandUIPlayerCardsPlane.removeAllChildren(true);
    },
    showChenghao:function(pos,chenghao)
    {
        var screenPos = this.getScreenPos(pos);
        var posUI = this.uiMap[screenPos];
        posUI.chengHao.setVisible(true);
        posUI.chenghaoName.setString(chenghao);
    },
    hideChenghao:function(pos)
    {
        var screenPos = this.getScreenPos(pos);
        var posUI = this.uiMap[screenPos];
        posUI.chengHao.setVisible(false);
    },
    showTuoGuan:function(pos,it)
    {
        if(GameGloble.isMyPos(pos) == true)
        {
            this.quxiaoTuoGuanBn.setVisible(it);
        }
        else
        {
            var screenPos = this.getScreenPos(pos);
            //显示托管图标
            this.uiMap[screenPos].tuoguan.setVisible(it);
        }

    },
    hideTuoGuan:function()
    {
        this.quxiaoTuoGuanBn.setVisible(false);
        for(var key in this.uiMap)
        {
            var oneUIData = this.uiMap[key];
            if(oneUIData.tuoguan == null)continue;
            oneUIData.tuoguan.setVisible(false);
        }
    },
    showDuanxian:function(pos,offline)
    {
        if(GameGloble.isMyPos(pos))return;
        var screenPos = this.getScreenPos(pos);
        var uidata = this.uiMap[screenPos];
        uidata.offline.setVisible(offline);
    },
    hideDuanxian:function()
    {
        for(var key in this.uiMap)
        {
            var uidata = this.uiMap[key];
            if(uidata == null)continue;
            uidata.offline.setVisible(false);
        }
    },
    clearChenghao:function()
    {
        for(var key in this.uiMap)
        {
            var oneUIData = this.uiMap[key];
            oneUIData.chengHao.setVisible(false);
        }
    },
    fillRemaincards:function(cardIndexs)
    {
        this.kandUiDiCardsPlane.removeAllChildren(true);
        for(var key in cardIndexs)
        {
            var oneCardIndex = cardIndexs[key];
            var oneCard = GameHelper.getCard(oneCardIndex);
            var newCardUI = CardUIManager.createEatScorePlaneCard(oneCard.cardNum,oneCard.cardType);
            newCardUI.MarginRight = 70;
            this.kandUiDiCardsPlane.addChild(newCardUI);
        }
        CocosHeler.UpdateMarginX(this.kandUiDiCardsPlane.getChildren(),this.kandUiDiCardsPlane);
    },
    fillPlayerRemainCards:function(cardIndexs)
    {
        this.kandUIPlayerCardsPlane.removeAllChildren(true);
        for(var key in cardIndexs)
        {
            var oneCardIndex = cardIndexs[key];
            var oneCard = GameHelper.getCard(oneCardIndex);
            var newCardUI = CardUIManager.createEatScorePlaneCard(oneCard.cardNum,oneCard.cardType);
            newCardUI.MarginRight = 70;
            this.kandUIPlayerCardsPlane.addChild(newCardUI);
        }
        CocosHeler.UpdateMarginX(this.kandUIPlayerCardsPlane.getChildren(),this.kandUIPlayerCardsPlane);
    },
    showTalk:function(pos,text,time)
    {
        var screenPos = this.getScreenPos(pos);
        var ui = this.uiMap[screenPos];
        ui.talkRoot.setVisible(true);
        ui.talkText.setString(text);
        ui.talkRoot.cleanup();
        var textWidth = text.length*ui.talkText.getFontSize();
        var bgHeight = ui.talkBG.getContentSize().height;
        ui.talkBG.setContentSize(cc.size(textWidth+30,bgHeight));
        var finalAction = cc.sequence(cc.fadeIn(0.001),cc.delayTime(time-1),cc.fadeOut(1));
        ui.talkRoot.runAction(finalAction);
    },
    clearTipCards:function()
    {
        this.haveTipIndexs = false;
        this.tipCards = [];
        this.tipIndex = 0;
    },
    showGetScoreFinishUI:function(data)
    {
        var win = false;
        this.showGetScoreUI.setVisible(true);
        this.showGetScoreAnimation.play("ShowUI",false);
        this.showGetScoreWinUI.setVisible(false);
        this.showGetScoreLoseUI.setVisible(false);
        this.showGetScorePingUI.setVisible(false);
        for(var key in this.uiMap)
        {
            var oneUIData = this.uiMap[key];
            var score = data[key].score.toFixed(2);
            oneUIData.showGetScoreName.setString(data[key].name);
            var scoreMark = "+";
            var scoreColor = cc.color(106,255,0,100);
            if(score<0)
            {
                scoreMark = "";
                scoreColor = cc.color(255,0,0,100);
            }

            if(GameGloble.isMyPos(key))//设置图标
            {
               if(score >0)
               {
                   //胜利
                   win = true;
                   this.showGetScoreWinUI.setVisible(true);
               }else if(score == 0)
               {
                   //平
                   win = false;
                   this.showGetScorePingUI.setVisible(true);
               }
                else if(score<0)
               {
                   //失败
                   win = false;
                   this.showGetScoreLoseUI.setVisible(true);
               }
            }

            score = scoreMark+score;
            oneUIData.showGetScoreScore.setString(score+"龙骨");
            oneUIData.showGetScoreScore.setTextColor(scoreColor);
        }
        //显示广告
        Ads.showGDTBanner();
        g_SoundManager.playGameFinishSound(win);
    },
    hideScoreFinishUI:function()
    {
        this.showGetScoreUI.setVisible(false);
    },
    showLongGuFinishUI:function(data)
    {
        var win = false;
        var length = 0;
        for(var key in data)
        {
            length+=1;
        }
        if(length != 4)return;

        this.showGetScoreUI.setVisible(true);
        this.showGetScoreAnimation.play("ShowUI",false);
        this.showGetScoreWinUI.setVisible(false);
        this.showGetScoreLoseUI.setVisible(false);
        this.showGetScorePingUI.setVisible(false);
        for(var key in this.uiMap)
        {
            var oneUIData = this.uiMap[key];
            var score = data[key].score;
            oneUIData.showGetScoreName.setString(data[key].name);
            var scoreMark = "+";
            var scoreColor = cc.color(106,255,0,100);
            if(score<0)
            {
                scoreMark = "";
                scoreColor = cc.color(255,0,0,100);
            }

            if(GameGloble.isMyPos(key))//设置图标
            {
                if(score >0)
                {
                    //胜利
                    this.showGetScoreWinUI.setVisible(true);
                    win = true;
                }else if(score == 0)
                {
                    //平
                    this.showGetScorePingUI.setVisible(true);
                    win = false;
                }
                else if(score<0)
                {
                    //失败
                    this.showGetScoreLoseUI.setVisible(true);
                    win = false;
                }
            }

            score = scoreMark+score;
            oneUIData.showGetScoreScore.setString(score+"  龙骨");
            oneUIData.showGetScoreScore.setTextColor(scoreColor);
        }
        g_SoundManager.playGameFinishSound(win);
    },
    showPlayerLeaveRankUI:function(type)//0为，有玩家离开，3秒后自动退出房间 1为有玩家龙骨数量不足，3秒后自动退出房间
    {
        this.leaveRankUI.setVisible(true);
        if(type == 0)
        {
            this.leaveRankUI.getChildByName("InfoText").setString("有玩家离开,3秒后自动离开房间！");
        }
        else
        {
            this.leaveRankUI.getChildByName("InfoText").setString("有玩家龙骨数量不足,3秒后自动离开房间！");
        }

        this.schedule(function()
        {
            cc.director.runScene(new ChooseGameUIScene());
        },0,0,3);
    },
    showPlayerLeaveOrStaUI:function(type)
    {
        //0表示比赛局数完成，1代表攉完一轮
        if(type == 0)
        {
            this.leaveOrStaUI.getChildByName("InfoText").setString("规定的局数内未完成比赛！");
        }
        else
        {
            this.leaveOrStaUI.getChildByName("InfoText").setString("攉完一轮啦！");
        }
        this.leaveOrStaUI.setVisible(true);
    },
    hidePlayerLeaveOrStaUI:function()
    {
        this.leaveOrStaUI.setVisible(false);
    },
    getTuCaoString:function(index)
    {
        var ss = this.tucaoUI.getChildByName("BG").getChildren();
        return ss[index].getString();
    },
    showPlayerInfo:function(pos,info)
    {
        var headUrl = GameGloble.getChengHaoHeadUrl(info.headurl);
        var nicheng = info.nicheng;
        var chenghao = info.chenghao;
        var longgu = info.longgu;
        var paiming = info.paiming;
        var longnum = info.longnum;

        this.baseInfoUI.showInfo(headUrl,nicheng,longgu,longnum,chenghao,paiming)
    },
    hidePlayerInfo:function()
    {
        for(var key in this.uiMap)
        {
            var oneUI = this.uiMap[key];
            oneUI.playerInfoUI.setVisible(false);
        }
    },
    showFinishDipaiUI:function(dicardIndexs)
    {
        this.finishDipaiUI.setVisible(true);
        this.finishDipaiUIDipaiPlane.removeAllChildren(true);
        for(var key in dicardIndexs)
        {
            var oneCardIndex = dicardIndexs[key];
            var oneCard = GameHelper.getCard(oneCardIndex);
            var cardUI = CardUIManager.createHandCard(oneCard.cardNum,oneCard.cardType);
            cardUI.MarginRight = cardUI.getContentSize().width;
            this.finishDipaiUIDipaiPlane.addChild(cardUI);
        }
        CocosHeler.UpdateMarginX(this.finishDipaiUIDipaiPlane.getChildren(),this.finishDipaiUIDipaiPlane);
    },
    hideFinishDipaiUI:function()
    {
        this.finishDipaiUI.setVisible(false);
    },
    showRemainJuNum:function(remainJu)
    {
        if(GameGloble.GameType == 0)return;
        var juss = remainJu.toString();
        var text1 = typeof  juss[1] == "undefined"?"":juss[1];
        var text2 = typeof  juss[0] == "undefined"?"":juss[0];
        this.juNumText2.setVisible(true);
        this.juNumText2.setString(text2);

        this.juNumText1.setVisible(true);
        this.juNumText1.setString(text1);

        this.juNumImage.setVisible(true);
        this.topBisaiImage.setVisible(true);
        this.topEndImage.setVisible(true);
    },
    hideRemainJuNum:function()
    {
        this.juNumText2.setVisible(false);
        this.juNumText1.setVisible(false);
        this.juNumImage.setVisible(false);
        this.topBisaiImage.setVisible(false);
        this.topEndImage.setVisible(false);
    },
    showLongguBuZuUI:function()
    {
        this.longgubuzuUI.setVisible(true);
    },
    hodeLongguBuzuUI:function()
    {
        this.longgubuzuUI.setVisible(false);
    },
    showChongZhiUI:function()
    {
        this.chongzhiUI.setVisible(true);
    },
    hideChongZhiUI:function()
    {
        this.chongzhiUI.setVisible(false);
    },
    showPowerUpUIWithData:function(powerupdata)
    {
        if(JSUseFullFramework.countJSON(powerupdata) == 0)return;
        for(var key in powerupdata)
        {
            var oneData = powerupdata[key];
            if(GameGloble.isMyPos(key))
            {
                if(oneData.powerup == true)
                {
                    this.showPowerUPUI(0,oneData.chenghao);
                }
                else
                {
                    this.showPowerUPUI(1,"",oneData.nextlongnum);
                }
                return;
            }
        }
    },
    showPowerUPUI:function(type,chenghao,nextlongnum)//type 0 为称号升级 type 1 为攉过的轮次数+1
    {
        var self = this;
        this.powerUpUI.setVisible(true);
        g_SoundManager.playPowerUpSound();

        this.schedule(function()
        {
            self.hidePowerUpUI();
        },0,0,4);
        if(type == 0)
        {
            this.powerUpUIAction.play("RunPowerUp",false);
            this.powerUpUIChenghaoText.setString(chenghao);
        }
        else if(type ==1)
        {
            this.powerUpUIAction.play("RunLunAdd",false);
            this.powerUpUINextLongNum.setString("距离下次升级还差"+nextlongnum+"轮");
        }
    },
    hidePowerUpUI:function()
    {
        this.powerUpUI.setVisible(false);
    },
    showPrepareInfo:function()
    {
        this.prepareBnTipInfo.setVisible(true);
        if(GameGloble.GameType == 1)
        {
            //30秒自动准备
            this.prepareBnTipInfo.setString("请点击开始，否则15秒后将自动准备...");
        }
        else
        {
            //30离开游戏
            this.prepareBnTipInfo.setString("请点击开始，否则15秒后将自动退出房间...");
        }
    },
    nextGame:function(dadiPos,kingNum,mainType,bifen)
    {
        var wofangNum = bifen[GameGloble.Pos].wofangHitNum;
        var duifangNum = bifen[GameGloble.Pos].duifangHitNum;
        this.showBifenText(wofangNum,duifangNum);
        //进入玩家准备状态
        //取消准备
        this.clearPrePare();
        this.setHeadAndName("bottom",GameGloble.ChenghaoHeadUrl,GameGloble.UserName);
        this.hideZhuang();
        this.showZhuang(dadiPos);
        this.hideTextTip();
        this.showTopZhuIcon();
        this.hideZhufuPlane();
        this.clearTipCards();
        this.hideKandiBn();
        this.hideKandiUI();
        this.clearKandiUICards();
        this.hideTuoGuan();
        this.lastSelectType = null;
        this.showDifen = false;
        this.prepareBn.setVisible(true);
        this.shanglunBn.setVisible(false);
        this.showPrepareInfo();

        this.firstHitCards = [];
        this.selectCardUIs =[];
        this.keyNum = kingNum;
        this.mainType = mainType;
        this.dadiPos =  dadiPos;
        this.totalEatScoreNum = 0;
        this.playingState = 0;

        g_SoundManager.playNormalBackGround();

    },
    clearUI:function()
    {
        this.hideHitCardUI();
        this.hideFanzhuUI();
        this.hideKoudiUI();
        this.hideTimeOut();
        this.hideZhaixingUI();
        this.hideZhaixingPlane();
        this.clearHitCardPlane();
        this.hideYaoxingUI();
        this.hideTextTip();
        this.clearHandCards();
        this.clearEatScoreUI();
        this.hideZhufuPlane();
        this.hideTopZhuIcon();
        this.hideScoreFinishUI();
        this.clearTipCards();
        this.hideKandiBn();
        this.hideKandiUI();
        this.clearKandiUICards();
        this.hideTuoGuan();
        this.lastSelectType = null;
        this.shanglunBn.setVisible(false);
        this.showDifen = false;
        this.isPlaying = false;
        this.playingState = 0;
        g_SoundManager.playNormalBackGround();
    },
    resetUI:function()
    {

        this.clearPrePare();
        this.clearHitCardPlane();
        this.hideFanzhuUI();
        this.hideKoudiUI();
        this.hideTimeOut();
        this.hideZhaixingUI();
        this.showBifenText(3,3);
        this.hideBifenText();
        this.hideZhaixingUI();
        this.clearEatScoreUI();
        this.hideZhuang();
        this.clearHitCardPlane();
        this.clearHandCards();
        this.hideTextTip();
        this.hideZhaixingPlane();
        this.hideTopZhuIcon();
        this.hideYaoxingUI();
        this.hideZhufuPlane();
        this.hideHitCardUI();
        this.hideTimeOut();
        this.clearTipCards();
        this.hideKandiBn();
        this.hideKandiUI();
        this.clearKandiUICards();
        this.hideTuoGuan();
        this.hideRemainJuNum();
        this.showPrepareInfo();
        this.lastSelectType = null;
        this.showDifen = false;
        this.shanglunBn.setVisible(false);//游戏结束隐藏查看上轮的按钮

        this.prepareBn.setVisible(true);
        this.setHeadAndName("bottom",GameGloble.ChenghaoHeadUrl,GameGloble.UserName);
        this.showChenghao(GameGloble.Pos,GameGloble.Chenghao);

        this.firstHitCards = [];
        this.selectCardUIs = [];
        this.keyNum = 3;
        this.mainType = 1;
        this.totalEatScoreNum = 0;
        this.playingState = 0;
        g_SoundManager.playNormalBackGround();
    },
    playerEnterTalbe:function(account,pos,name,headUrl,lt,isPrepared,chenghao)
    {
        var screenPos = this.getScreenPos(pos);
        var headUI = this.uiMap[screenPos].head;
        headUI.account  = account;
        headUI.pos = pos;
        this.setHeadAndName(screenPos,headUrl,name);
        this.setPrePare(screenPos,isPrepared);
        this.showChenghao(pos,chenghao);
    },
    playerLeaveTable:function(pos,isPlayering)
    {
        var screenPos = this.getScreenPos(pos);
        this.hideHeadAndName(screenPos);
        this.hidePrePare(screenPos);
        this.hideChenghao(pos);
        this.showDuanxian(pos,false);
        if(isPlayering)
        {
            //重置界面
            //this.resetUI();
        }
    },
    showShangshoupaiUI:function(shangshouData)
    {

        this.shanglunUI.setVisible(true);
        for(var key in shangshouData)
        {
            var indexs = shangshouData[key];
            var screenPos = this.getScreenPos(key);
            var plane = this.shanglunUI.getChildByName(screenPos);
            plane.removeAllChildren(true);
            var haveHitCard = false;
            for(var index in indexs)
            {
                haveHitCard = true;
                var oneCardIndex = indexs[index];
                var oneCard = GameHelper.getCard(oneCardIndex);
                var oneHitCardUI = CardUIManager.createHitCard(oneCard.cardNum,oneCard.cardType);
                oneHitCardUI.index = oneCardIndex;
                oneHitCardUI.MarginRight = oneHitCardUI.getContentSize().width-13;
                plane.addChild(oneHitCardUI);
            }
            this.shanglunUI.getChildByName("InfoText").setVisible(!haveHitCard);

            CocosHeler.UpdateMarginX(plane.getChildren(),plane);
            CocosHeler.centerMarginChilds(plane.getChildren(),plane);
        }
    },
    //玩家重新连接排位赛
    playerReconnectRankGame:function(netWorkData)
    {
        this.tableID = netWorkData.tableid;
        var gamestate = netWorkData.gamestate;
        this.keyNum = netWorkData.keynum;
        this.mainType = netWorkData.maintype;
        this.dadiPos =  netWorkData.zhuangpos;
        this.hitMarsk = netWorkData.hitmarsk;
        for(var pos in netWorkData.players)
        {
            var onePlayerData = netWorkData.players[pos];
            var account = onePlayerData.account;
            var screenPos = this.getScreenPos(pos);

            //设置头像和准备
            this.setPrePare(screenPos,onePlayerData.showprepare);
            var headURL = GameGloble.getChengHaoHeadUrl(onePlayerData.headurl,onePlayerData.chenghao);
            this.setHeadAndName(screenPos,headURL,onePlayerData.name);
            var headUI = this.uiMap[screenPos].head;
            headUI.account  = account;
            headUI.pos = pos;

            //设置托管和断线状态

            this.showTuoGuan(pos,onePlayerData.tuoguan);
            this.showDuanxian(pos,onePlayerData.offline);

            this.showChenghao(pos,onePlayerData.chenghao);
            this.prepareBn.setVisible(false);
            this.prepareBnTipInfo.setVisible(false);
            if(GameGloble.isMyPos(pos))//如果是自己，就发送准备事件,防止卡机，无法开始！！！
            {
                //发送准备事件
                if(this.mainType == -1)
                {
                    g_GameNetWork.crossSendData('preparestate',{ip:true});
                }
            }
            else
            {

            }
            //设置摘星数
            this.showZhaixingPlane(pos,onePlayerData.xingnum);
        }
        this.hideHeadAndName("bottom");
        this.hideChenghao(GameGloble.Pos);
        //显示比分
        var bifen = netWorkData.bifen[GameGloble.Pos];
        this.showBifenText(bifen.wofangHitNum,bifen.duifangHitNum);

        //显示剩余的局数
        this.showRemainJuNum(netWorkData.leftlun);

        //显示手里的牌
        var handCardIndexs = netWorkData.players[GameGloble.Pos].handcards;
        for(var cardIndex in handCardIndexs)
        {
            this.addOneHandCardIndex(handCardIndexs[cardIndex]);
        }
        this.repositionCardsNormal();//整理牌

        //显示主的数量和类型
        this.showZhufuPlane();

        //显示底牌
        this.fillRemaincards(netWorkData.dicards);
        if(netWorkData.xingnum >0 || GameGloble.isMyPos(netWorkData.zhuangpos))
        {
            this.fillPlayerRemainCards(netWorkData.playerdicards);
        }

        if(gamestate == 1)//游戏处于准备状态
        {
            this.setHeadAndName("bottom",GameGloble.ChenghaoHeadUrl,GameGloble.UserName);
            this.showChenghao(GameGloble.Pos,GameGloble.Chenghao);
        }
        else if(gamestate == 7)//游戏正处于扣底阶段
        {
            this.playingState = 2;
            this.showZhuang(netWorkData.zhuangpos);
            if(GameGloble.isMyPos(netWorkData.zhuangpos))
            {
                //防止还原的时候多次扣底
                if(netWorkData.playerdicards.length ==0) this.showKoudiUI();
            }
            else
            {
                this.showTextTip("正在等待其他玩家摘星或者扣底操作...");
            }
            this.showKandiBn();
        }
        else if(gamestate == 8)//游戏处于出牌阶段
        {
            this.prepareBn.setVisible(false);
            this.shanglunBn.setVisible(true);
            this.playingState = 3;
            this.showZhuang(netWorkData.zhuangpos);
            //显示吃分
            this.eatScore(netWorkData.eatscore.score,netWorkData.eatscore.cards);
            //显示当前谁在出牌
            this.turnToHitCard(netWorkData.truntohitcardpos);

            if(netWorkData.truntohitcardpos == netWorkData.firsthitcardpos && GameGloble.isMyPos(netWorkData.firsthitcardpos))//自己是第一个出牌的人
            {
                this.isFirstHitCard = true;//自己是第一个出牌的
            }
            else
            {
                this.firstHitCards = netWorkData.players[netWorkData.firsthitcardpos].hitCards;//每一轮第一次出的牌
                this.firstHitCardPos = netWorkData.firsthitcardpos;
            }

            //显示手上的牌
            for(var pos in netWorkData.players)
            {
                var hitCardIndexs = netWorkData.players[pos].hitCards;
                if(hitCardIndexs.length == 0)continue;
                this.showHitCards(pos,hitCardIndexs);
            }
            this.showKandiBn();
        }
        else
        {
            //显示打底玩家位置
            this.showZhuang(netWorkData.zhuangpos);
        }
    },
    playerReconnectNormalGame:function(netWorkData)
    {
        this.tableID = netWorkData.tableid;
        var gamestate = netWorkData.gamestate;
        this.keyNum = netWorkData.keynum;
        this.mainType = netWorkData.maintype;
        this.dadiPos =  netWorkData.zhuangpos;
        this.hitMarsk = netWorkData.hitmarsk;
        for(var pos in netWorkData.players)
        {
            var onePlayerData = netWorkData.players[pos];
            var account = onePlayerData.account;
            var screenPos = this.getScreenPos(pos);

            //设置头像和准备
            this.setPrePare(screenPos,onePlayerData.showprepare);
            this.setHeadAndName(screenPos,GameGloble.getChengHaoHeadUrl(onePlayerData.headurl,onePlayerData.chenghao),onePlayerData.name);
            var headUI = this.uiMap[screenPos].head;
            headUI.account  = account;
            headUI.pos = pos;

            //设置托管和断线状态

            this.showTuoGuan(pos,onePlayerData.tuoguan);
            this.showDuanxian(pos,onePlayerData.offline);

            this.showChenghao(pos,onePlayerData.chenghao);
            this.prepareBn.setVisible(false);
            if(GameGloble.isMyPos(pos))//如果是自己，就发送准备事件,防止卡机，无法开始！！！
            {
                //发送准备事件
                g_GameNetWork.crossSendData('preparestate',{ip:true});//为了防止卡机
                this.prepareBnTipInfo.setVisible(false);
            }
            else
            {

            }
            //设置摘星数
            this.showZhaixingPlane(pos,onePlayerData.xingnum);
        }
        this.hideHeadAndName("bottom");
        this.hideChenghao(GameGloble.Pos);
        //显示比分
        var bifen = netWorkData.bifen[GameGloble.Pos];
        this.showBifenText(bifen.wofangHitNum,bifen.duifangHitNum);

        //显示手里的牌
        var handCardIndexs = netWorkData.players[GameGloble.Pos].handcards;
        for(var cardIndex in handCardIndexs)
        {
            this.addOneHandCardIndex(handCardIndexs[cardIndex]);
        }
        this.repositionCardsNormal();//整理牌

        //显示主的数量和类型
        this.showZhufuPlane();

        //显示底牌
        this.fillRemaincards(netWorkData.dicards);
        if(netWorkData.xingnum >0 || GameGloble.isMyPos(netWorkData.zhuangpos))
        {
            this.fillPlayerRemainCards(netWorkData.playerdicards);
        }

        if(gamestate == 1)//游戏处于准备状态
        {
            this.setHeadAndName("bottom",GameGloble.ChenghaoHeadUrl,GameGloble.UserName);
            this.showChenghao(GameGloble.Pos,GameGloble.Chenghao);
        }
        else if(gamestate == 7)//游戏正处于扣底阶段
        {
            this.playingState = 2;
            this.showZhuang(netWorkData.zhuangpos);
            if(GameGloble.isMyPos(netWorkData.zhuangpos))
            {
                //防止还原的时候多次扣底
                if(netWorkData.playerdicards.length ==0) this.showKoudiUI();
            }
            else
            {
                this.showTextTip("正在等待其他玩家摘星或者扣底操作...");
            }
            this.showKandiBn();
        }
        else if(gamestate == 8)//游戏处于出牌阶段
        {
            this.prepareBn.setVisible(false);
            this.shanglunBn.setVisible(true);
            this.playingState = 3;
            this.showZhuang(netWorkData.zhuangpos);
            //显示吃分
            this.eatScore(netWorkData.eatscore.score,netWorkData.eatscore.cards);
            //显示当前谁在出牌
            this.turnToHitCard(netWorkData.truntohitcardpos);

            if(netWorkData.truntohitcardpos == netWorkData.firsthitcardpos && GameGloble.isMyPos(netWorkData.firsthitcardpos))//自己是第一个出牌的人
            {
                this.isFirstHitCard = true;//自己是第一个出牌的
            }
            else
            {
                this.firstHitCards = netWorkData.players[netWorkData.firsthitcardpos].hitCards;//每一轮第一次出的牌
                this.firstHitCardPos = netWorkData.firsthitcardpos;
            }

            //显示手上的牌
            for(var pos in netWorkData.players)
            {
                var hitCardIndexs = netWorkData.players[pos].hitCards;
                if(hitCardIndexs.length == 0)continue;
                this.showHitCards(pos,hitCardIndexs);
            }
            this.showKandiBn();
        }
        else
        {
            //显示打底玩家位置
            this.showZhuang(netWorkData.zhuangpos);
        
        }
    },
    showAds:function()
    {
        try
        {
            if(jsb)
            {
                if(cc.sys.os == cc.sys.OS_IOS)
                {
                    jsb.reflection.callStaticMethod("RootViewController","ShowGDTAds");
                }
                else if(cc.sys.os == cc.sys.OS_ANDROID)
                {
                    jsb.reflection.callStaticMethod("com/tongfei/ads/GDT", "showAds", "(I)V",3);
                }

            }
        }
        catch (e)
        {

        }

    }
});

var GameUIScene = cc.Scene.extend({
    onEnter:function () {
        this._super();

        var layer = new GameUILayer();
        if(typeof  this.reConnectData != "undefined")
        {
            layer.reConnectData = this.reConnectData;
        }
        this.addChild(layer);
    },
    setReconnectData:function(data)
    {
        this.reConnectData = data;
    }
});

