/**
 * Created by Administrator on 2016/1/13.
 */

var LoginUILayer = cc.Layer.extend({
    sprite:null,
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        GuiController.LoginUI = this;
        GuiController.CurrentUI = this;
        var self = this;
        var mainScene = ccs.load(res.LoginUI).node;
        this.addChild(mainScene);

        this.youkeLoginBn = mainScene.getChildByName("YoukeLoginBn");
        this.zhanghaoLoginBn = mainScene.getChildByName("ZhanghaoLoginBn");

        this.loginPlane = mainScene.getChildByName("LoginPlane");
        this.loginPlane.setVisible(false);
        this.loginPlaneAccount = this.loginPlane.getChildByName("Account");
        this.loginPlanePassWord = this.loginPlane.getChildByName("PassWord");
        this.loginQuickBn = this.loginPlane.getChildByName("QuckLoginBn");
        this.loginLoginBn = this.loginPlane.getChildByName("LoginBn");
        this.loginCloseBn = this.loginPlane.getChildByName("CloseBn");
        this.loginForgePass = this.loginPlane.getChildByName("ForgetPass");

        this.registerPlane = mainScene.getChildByName("RegisterPlane");
        this.registerPlane.setVisible(false);
        this.registerPlaneAccount = this.registerPlane.getChildByName("Account");
        this.registerPlanePass = this.registerPlane.getChildByName("PassWord");
        this.registerPlaneNicheng = this.registerPlane.getChildByName("Nicheng");
        this.registerPlaneShouji = this.registerPlane.getChildByName("Shouji");
        this.registerPlaneHead1 = this.registerPlane.getChildByName("Head1");
        this.registerPlaneHead1.selectName = "head1.png";
        this.registerPlaneHead2 = this.registerPlane.getChildByName("Head2");
        this.registerPlaneHead2.selectName = "head2.png";
        this.registerPlaneHead1Bg = this.registerPlane.getChildByName("Head1bg");
        this.registerPlaneHead2Bg = this.registerPlane.getChildByName("Head2bg");
        this.headMaps = {"Head1":this.registerPlaneHead1Bg,"Head2":this.registerPlaneHead2Bg};
        this.selectHeadUI = this.registerPlaneHead1;
        this.registerPlaneBackBn = this.registerPlane.getChildByName("BackBn");
        this.registerPlaneZhuceBn = this.registerPlane.getChildByName("OkBn");

        this.waitingUI = mainScene.getChildByName("WaitingUI");
        this.loginPlane.setVisible(true);
        GuiController.initQuitGameUI(mainScene);//返回键退出游戏

        this.findPassWordUI = GuiController.initFindPassWord(mainScene);
        //this.findPassWordUI.showFindPassWord("您的密码是");

        //设置游客登录点击事件
        CocosHeler.setOnClickEvent(this.youkeLoginBn,function()
        {
            //cc.director.runScene(new ChooseGameUIScene());
        },this);
        //点击账号密码登录
        CocosHeler.setOnClickEvent(this.zhanghaoLoginBn,function()
        {
            this.loginPlane.setVisible(true);
            g_SoundManager.playHitMenuSound();
        },this);
        //点击快速注册
        CocosHeler.setOnClickEvent(this.loginQuickBn,function()
        {
            this.loginPlane.setVisible(false);
            this.registerPlane.setVisible(true);
            g_SoundManager.playHitMenuSound();
        },this);

        //点击注册界面返回按钮
        CocosHeler.setOnClickEvent(this.registerPlaneBackBn,function()
        {
            this.loginPlane.setVisible(true);
            this.registerPlane.setVisible(false);
            g_SoundManager.playHitMenuSound();
        },this);
        //点击头像1
        CocosHeler.setOnClickEvent(this.registerPlaneHead1,function(wiget)
        {
            this.headClick(wiget);
        },this);
        CocosHeler.setOnClickEvent(this.registerPlaneHead2,function(wiget)//点击头像2
        {
            this.headClick(wiget);
        },this);
        //点击注册
        CocosHeler.setOnClickEvent(this.registerPlaneZhuceBn,function(wiget)//点击头像2
        {
            this.register();
        },this);
        //点击登录按钮
        CocosHeler.setOnClickEvent(this.loginLoginBn,function(wiget)
        {
            this.login();
            g_SoundManager.playHitMenuSound();
        },this);
        //点击登录关闭按钮
        CocosHeler.setOnClickEvent(this.loginCloseBn,function(wiget)
        {
            this.loginPlane.setVisible(false);
        },this);
        //点击背景
        CocosHeler.setOnClickEvent(this.waitingUI.getChildByName("BG"),function()
        {
            this.waitingUI.setVisible(false);
        },this);

        var socketClient = GameGloble.g_webSocketClient;
        if(socketClient.isConnected == false)GuiController.showWaitingUI(this.waitingUI,"正在连接服务器...",Number.MAX_VALUE);

        //监听网络连接事件
        socketClient.onConnectEvent.addEventListener("LoginUI",function()
        {
            self.waitingUI.setVisible(false);
            self.autoLogin();
        });
        socketClient.onCloseEvent.addEventListener("LoginUI",function()
        {
            GuiController.showWaitingUI(self.waitingUI,"网络不稳定，正在重新连接服务器...",Number.MAX_VALUE);
        });

        //测试安全存储
        //SafeSaveHttpData.safeSaveHttpData("http://localhost:18010/test");
        return true;
    },
    headClick:function(wiget)//点击头像，显示被选择
    {
        for(var key in this.headMaps)
        {
            var headUI = this.headMaps[key];
            headUI.setVisible(false);
        }
        var headName = wiget.name;
        var headUI = this.headMaps[headName];
        headUI.setVisible(true);
        this.selectHeadUI = wiget;
    },
    register:function()//注册账号
    {
        var userName = this.registerPlaneAccount.getString();
        var passWord = this.registerPlanePass.getString();
        var name = this.registerPlaneNicheng.getString();
        var shouji = this.registerPlaneShouji.getString();

        //userName = 'litengfei';
        //passWord = '123456';
        //name = '李腾飞';
        var waitingTime = 3;
        if(userName == '' || passWord == '' || name == '')
        {
            //提示用户名密码不能为空
            GuiController.showWaitingUI(this.waitingUI,"所有内容不能为空!",waitingTime);
            return;
        }
        //检测登录名是否合法
        if(InputCheck.isOutLength(10,userName) == false)
        {
            //提示用户名密码不能为空
            GuiController.showWaitingUI(this.waitingUI,"账号不能超过10个字符!",waitingTime);
            return;
        }
        //检测密码是否合法
        if(InputCheck.isOutLength(10,passWord) == false)
        {
            //提示用户名密码不能为空
            GuiController.showWaitingUI(this.waitingUI,"密码不能超过10个字符!",waitingTime);
            return;
        }
        //检测昵称是否合法
        if(InputCheck.isOutLength(5,name) == false)
        {
            //提示用户名密码不能为空
            GuiController.showWaitingUI(this.waitingUI,"昵称不能超过5个字符!",waitingTime);
            return;
        }

        //检查是否为11位手机号
        if(shouji.length > 0 && shouji.length != 11)
        {
            GuiController.showWaitingUI(this.waitingUI,"手机号为11位数字!",waitingTime);
            return;
        }

        var testShouji = new Number(shouji);
        if(testShouji.toString() == new Number('a').toString())
        {
            GuiController.showWaitingUI(this.waitingUI,"请填写正确的手机号!",waitingTime);
            return;
        }

        GameGloble.UserAccount = userName;
        GameGloble.UserPass = passWord;
        GuiController.showWaitingUI(this.waitingUI,"正在注册请稍后...",Number.MAX_VALUE);
        GameGloble.g_webSocketClient.crossSendData('register',{pa:userName,ps:passWord,pn:name,phu:this.selectHeadUI.selectName,sj:shouji});


    },
    login:function()//登录
    {
        var account = this.loginPlaneAccount.getString();
        var pass = this.loginPlanePassWord.getString();
        GameGloble.UserAccount = account;
        GameGloble.UserPass = pass;
        GameGloble.g_webSocketClient.crossSendData("login",{pa:account,ps:pass});

        //显示正在登录界面
        GuiController.showWaitingUI(this.waitingUI,"正在登录，请稍后...",Number.MAX_VALUE);
    },
    autoLogin:function()
    {
        var canAutoLogin = cc.sys.localStorage.getItem("CanAutoLogin");
        canAutoLogin = canAutoLogin == null?0:canAutoLogin;


        if(canAutoLogin == "1" && cc.sys.isMobile)
        {
            GuiController.showWaitingUI(this.waitingUI,"正在登录...",Number.MAX_VALUE,function(){});
            var account = cc.sys.localStorage.getItem("Account");
            var pass = cc.sys.localStorage.getItem("Pass");
            GameGloble.UserAccount = account;
            GameGloble.UserPass = pass;
            this.loginPlaneAccount.setString(GameGloble.UserAccount);
            GameGloble.g_webSocketClient.crossSendData("login",{pa:account,ps:pass});
        }
    },
    youkeLogin:function()//游客登录
    {

    },
    onExit:function()
    {
        this._super();
        GameGloble.g_webSocketClient.onConnectEvent.removeListener("LoginUI");
        GameGloble.g_webSocketClient.onCloseEvent.removeListener("LoginUI");
    }

});

var LoginUIScene = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new LoginUILayer();
        this.addChild(layer);
    }
});

